/////////////////////////////////////////////////////////////////////////////
// Albator.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Grincheux  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include "resource.h"
#include "../pluginvideo.h"
#include "../../K!TV-XP/externe/HtmlHelp.H"


#include "source/general.h"
#include "source/diversdeco.h"
#include "source/deco.h"
#include "source/filtresvideo.h"


BOOL APIENTRY PluginSetupProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);


QuenotteTV_VideoPlugin VideoPlugin ;
short *OddLines[5][288], *EvenLines[5][288];


// Copie des variables de K!TV : en lectures seules
int CurrentFrame, CurrentX;		// les + importants  tenir  jour !

CRITICAL_SECTION PluginVideoCrit; // Pour ne pas faire planter le plugin...

BOOL bFilterBlueLines, bFilterSecam;
BOOL MoreLinesLock=FALSE;	// Aie !
BOOL TypeImage;
BOOL PalPlusActive;
int StartAff=1;//Pour le desentrelacement on commence a zero et sans a 1 pour l'affichage de la video

int TZ[5];
int nPixelSchritt;
int MasterTestzeilen;		// Nombre actuel de couples
int iPixFilterThreshold;	// INI = SEUIL_NBPIX
int	iUFilterThresholdPCent, iVFilterThresholdPCent, iYUVFilterThresholdPCent; 
int BytesOut;				// Donner un nom + explicite !! 
int pSortLinesEven[ZEILENZAHL], pSortLinesOdd[ZEILENZAHL];
int InitialLow;

// Attention, veillez  choisir des valeurs >= 40100 pour les IDM suivants !
ACCEL AccTable[] =
{
	{ 0, 'f', 			IDM_SECAM_FILTER},	// F 
	{ FVIRTKEY | FCONTROL, 'F',	IDM_NOBLUELINES},	// CTRL+F
	{ 0, 'p',			IDM_PHASE_SECAM},
	{ 0, 'l',			IDM_MORETZ },
	{ FVIRTKEY | FCONTROL, 'L',	IDM_LESSTZ },
	{ FVIRTKEY | FALT,	'L',	IDM_LOCK },
	{ FVIRTKEY | FCONTROL, VK_F1, IDM_HELP_PLUGIN},	// HELP
	{ FVIRTKEY | FCONTROL, VK_F3, IDM_ADJUST_VIDEO},
	{ FVIRTKEY | FCONTROL, VK_F5, ID_OPT5},	// not used yet
	{ FVIRTKEY | FCONTROL, VK_F7, ID_OPT7},	// not used yet
	{ FVIRTKEY | FCONTROL, VK_F9, ID_OPT9},	// not used yet
	{ FVIRTKEY | FCONTROL, VK_F11, ID_OPT11}	// not used yet
};


/* cpu load	calculation (fasouil)	*/
static float	fCpuUsed;
static __int64	nReferTime;
inline __int64	GetRDTSCTime( void);


BOOL Init();
BOOL Start();
BOOL Stop();
void ShowDialog();

void InitStuff();
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer);
void PrepareUpdateScreen(BOOL);
void CheckStuff(void);

void Reset(BOOL ResetALL);
void GetStatus(char * Text, BOOL Nb);
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);
HMENU GetPluginMenu(BOOL ContextMenu);
void SetLow(unsigned char bBrightness);
BOOL AutoMovieBoostFound();
BOOL DetecteSignal(BYTE *pVBI);


// Chargement et dchargement de la DLL ...
// TODO: Y inclure mes fonctions Start & Stop
BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;

	UNREFERENCED_PARAMETER( hModule);
	UNREFERENCED_PARAMETER( lpReserved);
}




extern "C" __declspec(dllexport) QuenotteTV_VideoPlugin* GetVPlugin()
{
	VideoPlugin.description = "Albator707 1.9 (Grincheux)";
	VideoPlugin.version = VIDEO_PLUGIN_VERSION;
	VideoPlugin.VIA_FIX = FALSE;
	VideoPlugin.VIA_FIX_X=638;
	VideoPlugin.MovieBoost = 0;
	VideoPlugin.accel = &AccTable[0];
	VideoPlugin.NbAccel = sizeof(AccTable) / sizeof(AccTable[0]);
	VideoPlugin.DeInterlace = 0;

	VideoPlugin.Start=Start;
	VideoPlugin.Stop = Stop;
	VideoPlugin.ShowDialog = ShowDialog;

	VideoPlugin.InitStuff=InitStuff;
	VideoPlugin.DoStuff=DoStuff;
	VideoPlugin.CheckStuff=CheckStuff;

	VideoPlugin.GetStatus=GetStatus;
	VideoPlugin.ProcessMessage=ProcessMessage;
	VideoPlugin.GetPluginMenu=GetPluginMenu;
	VideoPlugin.SetLow=SetLow;
	VideoPlugin.AutoMovieBoostFound=AutoMovieBoostFound;
	VideoPlugin.DetecteSignal=DetecteSignal;
	
	Init();//Initialisationn chargement de l'ini...
	
	return &VideoPlugin;
}

// Lecture des paramtres  partir du fichier INI propre au plugin et 
// initialisation des variables globales.
BOOL Init()
{
	VideoPlugin.CurrentFrame =0; 
	VideoPlugin.CurrentX = 0;
	
	TZ[0]=16; TZ[1]=32;
	TZ[2]=48; TZ[3]=64; TZ[4]=80;
	MasterTestzeilen=48;
	iPixFilterThreshold=20;
	PalPlusActive = FALSE;
	InitialLow=45;

	iUFilterThresholdPCent=63;
	iVFilterThresholdPCent=63;
	iYUVFilterThresholdPCent=43;
	iPixFilterThreshold=20;

	nUThreshold= (int) (iUFilterThresholdPCent*0.01*0xff);
	nVThreshold= (int) (iVFilterThresholdPCent*0.01*0xff);
	nYUVThreshold= (int) (iYUVFilterThresholdPCent*0.01*0xff);

	bFilterBlueLines = TRUE;
	bFilterSecam = TRUE;
	Load_INI();
	return TRUE;
}


#define LIGNES_TEST_PHASE 288
void FindFrameType2(DWORD **pLinesAddress, int *pSortLines)
{
	int py;
	short * pLine;
	BYTE donnee[LIGNES_TEST_PHASE];
	int  NbTest1;
	int  NbTest2;

	// donnee contient toutes les valeurs V du 1e pixel de chaque ligne
	//for (py=0;py <LIGNES_TEST_PHASE; py ++)
	for (py=52;py <LIGNES_TEST_PHASE; py ++) //vite les premieres lignes pouvant tre bugnes
										     //car rsultat faux
	{
		pLine = VideoPlugin.EvenLines[CurrentFrame]	[py];
		donnee[py] = (BYTE) ((*pLine) >> 8);
	}

	NbTest1 = NbTest2 = 0;
	//for (py=0;py <LIGNES_TEST_PHASE; py += 2) {	
	for (py=52;py <LIGNES_TEST_PHASE-2; py += 2) {	//vite les premieres lignes pouvant tre bugnes
													//car rsultat faux
		if (donnee[py] == donnee[py+1])
			NbTest1 ++;
		if (donnee[py+1] == donnee[py+2])
			NbTest2 ++;
	}

	// On fait un test sur un grand nombre d'chantillon pour tre certain. 
	// En effet on peut avoir un U qui se repete sur plusieurs lignes ...
	if (NbTest1 < NbTest2)
		TypeImage = FALSE;
	else
		TypeImage = TRUE;	

	UNREFERENCED_PARAMETER( pSortLines);
	UNREFERENCED_PARAMETER( pLinesAddress);
}


BOOL Start()
{
	BOOL	bRc = FALSE;


	InitializeCriticalSection(&PluginVideoCrit);
	EnterCriticalSection(&PluginVideoCrit);
	Init();

	if ( LeseKeyDatei() && Init_Decoding(MasterTestzeilen))	{
		bRc = TRUE;
	}
	LeaveCriticalSection(&PluginVideoCrit);
	return( bRc);
}


BOOL Stop()
{
	EnterCriticalSection(&PluginVideoCrit);
	Free_Decoding();
	Write_INI();
	LeaveCriticalSection(&PluginVideoCrit);
	DeleteCriticalSection(&PluginVideoCrit);
	return TRUE;
}


void ShowDialog()
{
	DialogBox (VideoPlugin.hDllInstance, "REGLAGES", VideoPlugin.hwndParent, PluginSetupProc);
}


// Initialisation avant toute utilisation du thread d'affichage
// Il est CAPITAL de faire appel  cette fonction, sinon plantages...
//
void AjusteOdd();
void AjusteEven();
void AjusteHF(BOOL bIsOdd);

void InitStuff()
{
	int i;

	CurrentX = VideoPlugin.CurrentX;
	nPixelSchritt = CurrentX/TESTPIXEL/2;
	for ( i = 0; i < ZEILENZAHL; i++) BlackSet[i]=FALSE;
	Init_More();

	BytesOut=CurrentX*2;
	Clear_Status(); // <<<//

	// Rordonne les lignes (pour le traitement ultrieur)
	// On suppose que VideoPlugin.OddLines/EvenLines ne change jamais
	// Ca sera toujours le cas (ca pointe vers la mmoire vido)
	for (CurrentFrame = 0; CurrentFrame < 5; CurrentFrame++) 
	{
//		if (! VideoPlugin.FullField)
//			AjusteHF();		else 
		{
			AjusteEven();
			AjusteOdd();
		}
	}
	nReferTime = GetRDTSCTime();
}


void AjusteOdd()
{
int i, NextFrame;

	if (CurrentFrame == 4) 
		NextFrame=0;
	else
		NextFrame = (CurrentFrame % 5) + 1;

	for (i=0; i <255; i++)
		OddLines [CurrentFrame][i+32] = VideoPlugin.OddLines[CurrentFrame][i];

	// = image suivante even
	for (i=255; i <287; i++)
		EvenLines[NextFrame][i-255] = VideoPlugin.OddLines[CurrentFrame][i];

	OddLines[CurrentFrame][287] = VideoPlugin.OddLines[CurrentFrame][287];
}

void AjusteEven()
{
int i;

	for (i=0; i <255; i++)
		EvenLines[CurrentFrame][i+32] = VideoPlugin.EvenLines[CurrentFrame][i];

		// = image actuelle odd
	for (i=255; i <287; i++)
		OddLines[CurrentFrame][i-255] = VideoPlugin.EvenLines[CurrentFrame][i];

	EvenLines[CurrentFrame][287] = VideoPlugin.EvenLines[CurrentFrame][287];
}


void AjusteHF(BOOL bIsOdd)
{
int i, NextFrame;

	if (CurrentFrame == 4) 
		NextFrame=0;
	else
		NextFrame = (CurrentFrame % 5) + 1;

	if (bIsOdd)
	{
		for (i=255; i <287; i++)
			EvenLines[NextFrame][i-255] = VideoPlugin.OddLines[CurrentFrame][i];
	}
	else
	{
		for (i=0; i <255; i++)
			EvenLines[CurrentFrame][i+32] = VideoPlugin.EvenLines[CurrentFrame][i];
	}
}



// Effectue les calculs internes
//
// UpdateBuffer :
// True : la trame isodd doit etre copie dans le buffer vido
// False: ne rien faire

// ViewBuffer
// true : le buffer vido doit etre visible (overlayflip)
// false: ne pas flip(er)
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer)
{
	int nPALplusZeile  = -10, nPALplusData = 0;
	CurrentFrame = VideoPlugin.CurrentFrame;
	static __int64	nTimeCurrent, nDeltaTime, nTimeProcess;
	static float	fCpuCurrent;


	EnterCriticalSection(&PluginVideoCrit);

	/* init cpu time calculation	*/
	nTimeCurrent = GetRDTSCTime();
	nDeltaTime = nTimeCurrent - nReferTime;
	nReferTime = nTimeCurrent;

	if ( ! VideoPlugin.FullField) {// mode HF
		// R-ordonne les lignes pour tout avoir en EvenLines
		AjusteHF( !bIsOdd);	// Grincheux : 1.9
		
		if ( bIsOdd) {
			FindYUVLineOrder( &EvenLines[CurrentFrame][0], &pSortLinesEven[0],&nPALplusZeile,&nPALplusData);

			if ( bFilterBlueLines) {
				FindFrameType2((DWORD**)(&EvenLines[CurrentFrame][0]), &pSortLinesEven[0]);
				SecamFiltering((DWORD**)(&EvenLines[CurrentFrame][0]), &pSortLinesEven[0]);
			}
			if ((!MoreLinesLock) && ( FirstWidthOdd > 0))
				More_Even(nPALplusZeile);	

			PrepareUpdateScreen(FALSE);		// Seul EvenLines est lu en HF
			*ViewBuffer=TRUE;
			*UpdateBuffer=TRUE;
		} else {
			// Ne fait rien
			*ViewBuffer=FALSE;
			*UpdateBuffer=FALSE;
		}
//		LeaveCriticalSection(&PluginVideoCrit);
//		return; 
	} else {

		if ( !bIsOdd) {
			FindYUVLineOrder(&EvenLines[CurrentFrame][0], &pSortLinesEven[0], &nPALplusZeile, &nPALplusData);
		
			if ((!MoreLinesLock) && ( FirstWidthOdd > 0))
				More_Even(nPALplusZeile);

			if ( bFilterBlueLines) {
				FindFrameType2((DWORD**)(&EvenLines[CurrentFrame][0]), &pSortLinesEven[0]);
				SecamFiltering((DWORD**)(&EvenLines[CurrentFrame][0]), &pSortLinesEven[0]);
			}
		} else {
			FindYUVSecondLineOrder(&OddLines[CurrentFrame][0], &pSortLinesOdd[0]);
		
			TypeImage=!(TypeImage);
			if (bFilterBlueLines) 
				SecamFiltering((DWORD**)(&OddLines[CurrentFrame][0]), &pSortLinesOdd[0]);
			if ((!MoreLinesLock) && ( FirstWidthOdd > 0))
				More_Odd();
		}	 

		PrepareUpdateScreen(bIsOdd);

		// Copier vers le buffer toutes les trames
		*UpdateBuffer=TRUE;

		// N'Afficher que lorsque la trame paire puis impaire a t trait
		*ViewBuffer=bIsOdd;
	}

	/*	calcul CpuUsed	from MeuhMeuhPlug (Fasouil)	*/
	nTimeProcess = GetRDTSCTime() - nTimeCurrent;
	if ( nDeltaTime > 0) {
		fCpuCurrent = (float)nTimeProcess * 100 / nDeltaTime;

		//average (low pass filter)
		fCpuUsed = ( fCpuUsed * 80 + fCpuCurrent) / 81;
		if ( fCpuUsed > 100)
			fCpuUsed = 100;
	}
	
	LeaveCriticalSection(&PluginVideoCrit);
}


void PrepareUpdateScreen(BOOL bIsOdd)
{
	int i;

	if (bIsOdd)
	{
		for ( i=0; i < 287; i++ )
			VideoPlugin.OutOddLines[CurrentFrame][i] = OddLines[CurrentFrame][pSortLinesOdd[i]];
		i = 287;
		VideoPlugin.OutOddLines[CurrentFrame][i] = OddLines[CurrentFrame][i];
		return;
	}
	else
	{
		for ( i=0; i < 287; i++ )
			VideoPlugin.OutEvenLines[CurrentFrame][i] = EvenLines[CurrentFrame][pSortLinesEven[i]];
	
		// Derniere ligne intacte
		i = 287;
		VideoPlugin.OutEvenLines[CurrentFrame][i] = EvenLines[CurrentFrame][i];
	}
}

// Permet de passer un paramtre de vitesse au plugin.
// Ici permet de changer le nombre de couples.
// Pour acclerer suffit de donner une valeur positive
// TODO => Metter un #define  la place 
BOOL PluginSetSpeed(int speed)
{
	int i;	
	
	EnterCriticalSection(&PluginVideoCrit);

	if (speed > 0) // Augmente le couple
	{
		for ( i = 0; i < 5 ; i++ )
		{
			if( MasterTestzeilen < TZ[i])
			{
				MasterTestzeilen=TZ[i];
				break;
			}
		}
	}
	else		// diminue le couple
	{
		for ( i = 4; i >= 0 ; i-- )
		{
			if( MasterTestzeilen > TZ[i])
			{
				MasterTestzeilen=TZ[i];
				break;
			}
		}
	}
	if ( !Init_Decoding(MasterTestzeilen))
	{
		LeaveCriticalSection(&PluginVideoCrit);
		return FALSE;
	}

	if ( MatrixModeEven == TRUE )	GetMatrix(MatrixLinesEven-1,0);
	if ( MatrixModeOdd == TRUE )	GetMatrix(MatrixLinesOdd-1,1);
	
	LeaveCriticalSection(&PluginVideoCrit);
	return TRUE;
}



void CheckStuff(void)
{
	if (VideoPlugin.FullField)
	{

		if (MoreLinesLock==FALSE)
		{
			if (( MatrixModeOdd == TRUE ) && ( MatrixModeEven == TRUE )) MoreLinesLock=TRUE;
			if ( AutoLockCount < 10 ) AutoLockCount++;
			else MoreLinesLock=TRUE;
			if ( MoreLinesLock == TRUE )
			{
				if (( Line1BlackEven == FALSE ) &&
					( Line285BlackEven == FALSE ) && 
					( Line286BlackEven == FALSE ) && 
					( MatrixModeEven == FALSE ))	UntilEven=1;
				if (( Line1BlackOdd == FALSE ) && 
					( Line285BlackOdd == FALSE ) && 
					( Line286BlackOdd == FALSE ) && 
					( MatrixModeOdd == FALSE )) UntilOdd=1;
			}
			
		}
		else
		{
			if (Check_Odd() == FALSE ) Clear_Status();
		}
	}
	else
	{
		if (MoreLinesLock==FALSE)
		{
			if ( MatrixModeEven == TRUE ) MoreLinesLock=TRUE;
			if ( AutoLockCount < 10 ) AutoLockCount++;
			else MoreLinesLock=TRUE;
			if ( MoreLinesLock == TRUE )
			{
				if (( Line1BlackEven == FALSE ) && 
					( Line285BlackEven == FALSE ) && 
					( Line286BlackEven == FALSE ) && 
					( MatrixModeEven == FALSE )) UntilEven=1;
			}
		}
		else
		{
			if (Check_Even() == FALSE ) Clear_Status();
		}
	}
}


// Egalement le status mais une version "light" 
// Gnralement pour l'afficher dans la barre de status
void GetStatus(char *Text, BOOL Nb)
{
	char		Text1[256] = {'\0'};
	static bool	bDisplayCpu = false;


	if ( Nb) {
		if ( !bDisplayCpu) {
			if ( FirstWidthEven == TESTPIXEL ) {
				if (Line0BlackEven) strcat(Text,"E0");
			} else {
				if (Line0BlackEven) {
					sprintf(Text1,"+HE(%d)",FirstWidthEven);
					strcat(Text,Text1);
				}
			}
			if ( MatrixModeEven == TRUE ) {
				sprintf(Text1,"+ME %d",MatrixLinesEven);
				strcat(Text,Text1);
			} else { 
				if (Line1BlackEven) strcat(Text,"+E1");
				if (Line285BlackEven) strcat(Text,"+E285");
				if (Line286BlackEven) strcat(Text,"+E286");
			}
	
			if ( FirstWidthOdd == TESTPIXEL ) {
				if (Line0BlackOdd) strcat(Text,"+O0");
			} else {
				if (Line0BlackOdd) {
					sprintf(Text1,"+HO(%d)",FirstWidthOdd);
					strcat(Text,Text1);
				}
			}
			if ( MatrixModeOdd == TRUE ) {
				sprintf(Text1,"+MO %d",MatrixLinesOdd);
				strcat(Text,Text1);
			} else {
				if (Line1BlackOdd) strcat(Text,"+O1");
				if (Line285BlackOdd) strcat(Text,"+O285");
				if (Line286BlackOdd) strcat(Text,"+O286");
			}	
	
			if ( MoreLinesLock == FALSE ) {
				if (VideoPlugin.FullField == TRUE )
					sprintf(Text1,"(Stab) (%d/%d)",FirstWidthEven,FirstWidthOdd);
				else
					sprintf(Text1,"(Stab) (%d)",FirstWidthEven);
				strcat(Text,Text1);
			} else
				strcat(Text,"  (Lock)");
		} else {
			sprintf( Text, "CPU %.1f%%", fCpuUsed);
		}
		bDisplayCpu = !bDisplayCpu;
	} else {
		sprintf( Text, "%s %dTZ",
				(VideoPlugin.FullField == TRUE) ? "FF": "HF",
				MasterTestzeilen);
	}
}



// Si l'on veut pour rinitialiser le filtre
void Reset(BOOL ResetALL)
{
	// MoreLinesLock est souvent appel lors d'un changement du plugin
	MoreLinesLock = FALSE;
	if (ResetALL == FALSE)
		TypeImage = !TypeImage;	
	else 
		Clear_Status(); // TODO 
}


BOOL AutoMovieBoostFound()
{
int i;

	i = max (MatrixLinesEven, MatrixLinesOdd);
	if ( ( VideoPlugin.MovieBoost != i) && (MoreLinesLock == TRUE ) )
	{
		VideoPlugin.MovieBoost = i;
		return TRUE;
	}
	else return FALSE;
}


HMENU GetPluginMenu( BOOL ContextMenu)
{
	HMENU CurMenu;
	CurMenu = LoadMenu(VideoPlugin.hDllInstance, "PLUGIN_MENU_VIDEO"); 
	if (bFilterBlueLines == TRUE)	CheckMenuItem( CurMenu, IDM_NOBLUELINES, MF_CHECKED );
	if (bFilterSecam == TRUE)	CheckMenuItem( CurMenu, IDM_SECAM_FILTER, MF_CHECKED );
	return CurMenu;

	UNREFERENCED_PARAMETER( ContextMenu);
}


BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, 
									  char *OSDDisplay)
{
	BOOL MessageProcessed;

	MessageProcessed = FALSE;
	switch (message)
	{
		case WM_COMMAND:
			switch( LOWORD( wParam ))
			{
				case IDM_LOCK :
					if ( MoreLinesLock==TRUE )
					{
						MoreLinesLock=FALSE;
						sprintf (OSDDisplay,"Stab Reset");
					}
					else
					{
       					sprintf (OSDDisplay,"Stab Lock");
						MoreLinesLock=TRUE;
					}
					MessageProcessed = TRUE;
		            break;

				case IDM_NOBLUELINES :
					bFilterBlueLines = !bFilterBlueLines;
					
					if (bFilterBlueLines)
					{
						sprintf (OSDDisplay, "Filtre Bleu Activ");
						CheckMenuItem( GetMenu(VideoPlugin.hwndParent), IDM_NOBLUELINES, MF_CHECKED );
					}
					else 
					{
						sprintf (OSDDisplay, "Filtre Bleu Dsactiv");
						CheckMenuItem( GetMenu(VideoPlugin.hwndParent), IDM_NOBLUELINES, MF_UNCHECKED );
					}
					MessageProcessed = TRUE;
					break;

				case IDM_SECAM_FILTER:
					bFilterSecam = !bFilterSecam;
					if (bFilterSecam)
					{
						sprintf (OSDDisplay, "Filtre Anti-Bavures Activ");
						CheckMenuItem( GetMenu(VideoPlugin.hwndParent), IDM_SECAM_FILTER, MF_CHECKED );
					}
					else 
					{
						sprintf (OSDDisplay, "Filtre Anti-Bavures Dsactiv");
						CheckMenuItem( GetMenu(VideoPlugin.hwndParent), IDM_SECAM_FILTER, MF_UNCHECKED );
					}

					MessageProcessed = TRUE;
					break;

				case IDM_PHASE_SECAM:
					TypeImage = !TypeImage;
					sprintf(OSDDisplay, "");
					MessageProcessed = TRUE;
					break;

				case IDM_LESSTZ:
				case IDM_MORETZ:
					PluginSetSpeed( LOWORD( wParam) == IDM_MORETZ ? 1 : -1);
//					if (wParam == IDM_MORETZ) 	PluginSetSpeed(1);
//					else 						PluginSetSpeed(-1);
					sprintf (OSDDisplay, "Lignes de couples : %d", MasterTestzeilen);
					MessageProcessed = TRUE;
					break;

				case IDM_HELP_PLUGIN: //Affichage de l'aide en ligne des plugins
		            if ( HtmlHelp( GetDesktopWindow(),
								"Aide/AidePlugin.chm::/0Plugin.htm",
								HH_DISPLAY_TOPIC,
								NULL) == NULL) {
						sprintf( OSDDisplay, "Aide Plugin manquant");
						MessageProcessed = TRUE;
					}
					break;

				case IDM_ADJUST_VIDEO :

					ShowDialog();
					break;

			}
			break;
	}
	return MessageProcessed;

	UNREFERENCED_PARAMETER( lParam);
}
