/////////////////////////////////////////////////////////////////////////////
// Deco.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Grincheux  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>		// required for all Windows applications
#include <stdio.h>
#include <stdlib.h>			// atoi, free 
#include <io.h>
#include <fcntl.h>			// _O_BINARY

#include "general.h"
#include "Deco.h"
#include "diversdeco.h"



short pPALplusCode[] = {  18,  27,  36,  45,  54,  63,  72,  81,  90, 100, 110, 120, 134, 149};
short pPALplusData[] = { 160, 178, 196, 214, 232, 250, 268, 286, 304, 322, 340, 358, 376, 394};
int nTestzeilen;
int MoreTestZeilen;
short nLevelLow      =  45;
short nLevelHigh     = 135;
short pTestPixel_firstfield[ZEILENZAHL][TESTPIXEL*2];
int	nPaarIndexAnzahl;
int	nPaarIndexLOW;
int	nPaarIndexHIGH;
int LastMatrix[2]={0,0}; 

int *nPaarNummer;
int *nPaarDanach;
int *nPaarDavor;
int *nPaarTreffer;
int *nPaarInsert;
int *nPaarIndexA=NULL;
int *nPaarIndexB=NULL;
unsigned int nZeilenPaarKorrelation[INDEXSIZE]; 

int	nAnzahlPaare;
unsigned int MatrixKey;
char	pKeys[256];
unsigned short *pKombinationen = NULL;

const __int64 One       = 0x0001000100010001;
const __int64 nMaske    = 0x00ff00ff00ff00ff;
__int64  CurrentLowValue    = 0x002d002d002d002d;
int    BLData =  0;


void Free_Decoding(void)
{
	if ( pKombinationen != NULL ) free(pKombinationen);
    pKombinationen=NULL;
	if ( nPaarIndexA != NULL ) free(nPaarIndexA);
    nPaarIndexA=NULL;
	if ( nPaarIndexB != NULL ) free(nPaarIndexB);
    nPaarIndexB=NULL;
}	

BOOL Init_Decoding( int Lines )
{
	LastMatrix[0]=0;
    LastMatrix[1]=0;
	if (!LeseKeyDatei()) return(FALSE);
	Free_Decoding();

	nTestzeilen = Lines;
	MoreTestZeilen= nTestzeilen+7;
	pKombinationen = (unsigned short *)calloc(KOMBINATIONEN*MoreTestZeilen,sizeof(unsigned short));
	if ( LeseIndexDatei() == FALSE )
	{
// desactiv pour le passage  la DLL - 18/6/2001
//		OSD_Clear(hWnd,0);
		BaueIndex();
		SchreibeIndexDatei();
	}
	return(TRUE);
};


BOOL LeseKeyDatei()
{
	// Permutationstabelle aus Datei einlesen
	int   nZlr;
	int   nInputValue;
	FILE *sFile;

	sFile = fopen( Grincheux, "r");

	// Fr den Fall das die Datei nicht gelesen werden kann,
	// pKey vorbelegen sonst gibts einen UAE
	for(nZlr=0; nZlr<256; nZlr++)
		pKeys[nZlr] = (char)(nZlr&0x1f);

	if(sFile == NULL)
	{
		ErreurFatale("Blanche neige s'est perdue dans la fort");
		MessageBeep(MB_ICONEXCLAMATION);
		return FALSE;
    }
	for(nZlr=0; nZlr<256; nZlr++)
    {
		if(fscanf(sFile, "%d\n", &nInputValue) == EOF)
		{
 			ErreurFatale("Blanche neige est malade");
			MessageBeep(MB_ICONEXCLAMATION);
			fclose(sFile);
			return FALSE;
		}
		pKeys[nZlr] = (char)(nInputValue&0x1f);
    }
	fclose(sFile);
    return TRUE;
}


BOOL GetMatrix(int BlackWert,int evenodd)
{
	if ( LastMatrix[evenodd] == BlackWert ) return(TRUE);

	if ( LeseMatrixDatei(BlackWert,evenodd) == FALSE )
	{
		BaueMatrix(BlackWert,evenodd);
		SchreibeMatrixDatei(BlackWert,evenodd);
	}
	LastMatrix[evenodd] = BlackWert; 
	return(TRUE);
}


void BaueMatrix(int BlackWert,int evenodd)
{
	int nKey;
	int pZeilen[ZEILENZAHL];
	int i,j,k,l;
	unsigned int *pM;

	for(nKey=0; nKey<KOMBINATIONEN; nKey++)
    {
		BerechnePermutation(nKey, pZeilen);
		pM=(unsigned int *)&pKombinationen[MoreTestZeilen*nKey+evenodd*2];
		*pM=0;

		for ( i=0; i < BlackWert; i++ )
		{
			j= pZeilen[i];
			if ( j < 64 )
			{
				k=j/32;
				l=( j - ( k*32 ));
				if ( k == 1 )
				{
					*pM=*pM+( 1 << l );
				}
			} 
		} 

		for ( i=ZEILENZAHL-BlackWert; i < ZEILENZAHL; i++ )
		{
			j= pZeilen[i];
			if ( j < 64 )
			{
				k=j/32;
				l=( j - ( k*32 ));
				if ( k == 1 )
				{
					*pM=*pM+( 1 << l );
				}
			}
		} 
	}
}


BOOL LeseMatrixDatei( int Matrixsize, int evenodd)
{
	FILE *sFile;
	int nKey;

	unsigned int *pM;
	unsigned int Matrix[KOMBINATIONEN];

	// Datei mit vorberechneten Tabellen einlesen
	char pDateiName[255];
   
	sprintf(pDateiName, "%sMatrix%02d.%s", PLUGIN_SUBDIR, Matrixsize,Idefix);

	// Datei zum lesen ffnen
	sFile = fopen(pDateiName, "rb");
	if(sFile == NULL)
	{
		return FALSE;
	}
	if ( fread(&Matrix[0], sizeof(unsigned int), KOMBINATIONEN, sFile) != (size_t)KOMBINATIONEN)
	{
		fclose(sFile);
		return FALSE;
    }
	fclose(sFile);

	for(nKey=0; nKey<KOMBINATIONEN; nKey++)
    {
		pM=(unsigned int *)&pKombinationen[MoreTestZeilen*nKey+evenodd*2];
		*pM=Matrix[nKey];
	}
	return(TRUE);
}


BOOL SchreibeMatrixDatei( int Matrixsize,int evenodd)
{
	FILE *sFile;
	int nKey;

	// Datei mit vorberechneten Tabellen einlesen
	char pDateiName[255];
	unsigned int *pM;
	unsigned int Matrix;

	sprintf(pDateiName, "%sMatrix%02d.%s", PLUGIN_SUBDIR, Matrixsize, Idefix);
	CreateDirectory( PLUGIN_SUBDIR, (LPSECURITY_ATTRIBUTES)NULL);	

	// Datei zum schreiben ffnen
	sFile = fopen(pDateiName, "wb");
	if(sFile == NULL)	return FALSE;
	
	for(nKey=0; nKey<KOMBINATIONEN; nKey++)
	{
		pM=(unsigned int *)&pKombinationen[MoreTestZeilen*nKey+evenodd*2];
		Matrix=*pM;
		if(fwrite(&Matrix, sizeof(unsigned int), 1, sFile) != (size_t)1)
		{
			fclose(sFile);
			return FALSE;
		}
	}
	fclose(sFile);
	return(TRUE);
}


BOOL BaueIndex()
{
	int nZeilenIndex;
	int nPaarDavorIndex;
	int nPaarDanachIndex;
	int nKey;
	int pZeilen[ZEILENZAHL];
	int nZeileA;
	int nZeileB;
	int nCount = 0;
	int nTreffer;
	int nMaxTreffer;
   
	nAnzahlPaare = GROESSTE_ZEILE - KLEINSTE_ZEILE;

	nPaarNummer    = (int *)calloc(KOMBINATIONEN,sizeof(int));
	// In dieser Tabelle stehen alle Testzeilen einer Kombination hintereinander
	nPaarDanach    = (int *)calloc(KOMBINATIONEN*nAnzahlPaare,sizeof(int));
	nPaarDavor     = (int *)calloc(ZEILENZAHL*ZEILENZAHL,sizeof(int));
	nPaarTreffer   = (int *)calloc(ZEILENZAHL*ZEILENZAHL,sizeof(int));
	nPaarTreffer   = (int *)calloc(ZEILENZAHL*ZEILENZAHL,sizeof(int));
	nPaarInsert    = (int *)calloc(ZEILENZAHL*ZEILENZAHL,sizeof(int));

	nPaarIndexA    = (int *)calloc(INDEXSIZE,sizeof(int));
	nPaarIndexB    = (int *)calloc(INDEXSIZE,sizeof(int));

	// Kennzeichen fr nicht belegt
	for(nZeilenIndex=0; nZeilenIndex<ZEILENZAHL*ZEILENZAHL; nZeilenIndex++)
	{
		nPaarDavor[nZeilenIndex] = -1;
		nPaarInsert[nZeilenIndex]= 0;
	}

	// Anzahl Treffer auf Null setzen
	for(nZeilenIndex=0; nZeilenIndex<ZEILENZAHL*ZEILENZAHL; nZeilenIndex++)
		nPaarTreffer[nZeilenIndex] = 0;

    // Schleife ber alle Kombination
	for(nKey=0; nKey<KOMBINATIONEN; nKey++)
	{

// Desactive 18/6/2001
// pour le passage  la DLL

		// Zeilenfolge fr diese Kombination finden
/*		if ( Display_Status_Bar == TRUE )
		{
			if (( nKey&4 ) || ( nKey+1==KOMBINATIONEN))
			{
				DisplayStatusBar("Combinaison %d ",nKey);
			}
		}

		if ( PeekMessage(&msg,hwndTextField,0,0xffffffff,PM_REMOVE) == TRUE )
		{
			SendMessage(hwndTextField,msg.message,msg.wParam,msg.lParam);
		}

       if ( PeekMessage(&msg,hWnd,0,0xffffffff,PM_REMOVE) == TRUE )
		{
			SendMessage(hWnd,msg.message,msg.wParam,msg.lParam);
		}
*/
		BerechnePermutation(nKey, pZeilen);
		pKombinationen[MoreTestZeilen*nKey+4] = (unsigned short)pZeilen[1];
		pKombinationen[MoreTestZeilen*nKey+5] = (unsigned short)pZeilen[286];
		pKombinationen[MoreTestZeilen*nKey+6] = (unsigned short)pZeilen[285];

		// Erste Zeile eines Paars
		nZeileA = pZeilen[KLEINSTE_ZEILE];
		for(nZeilenIndex=KLEINSTE_ZEILE+1; nZeilenIndex<=GROESSTE_ZEILE; nZeilenIndex++)
		{
			// Zweite Zeile eines Paars
			nZeileB = pZeilen[nZeilenIndex];

			// Index immer aus "kleine Zeile * Zeilenzahl + groe Zeile" berechnen
			if(nZeileB < nZeileA)	nPaarDavorIndex = nZeileB*ZEILENZAHL + nZeileA;
			else	nPaarDavorIndex = nZeileA*ZEILENZAHL + nZeileB;

			// Index auf die Paar danach Tabelle
			nPaarDanachIndex = nKey*nAnzahlPaare + nZeilenIndex - (KLEINSTE_ZEILE+1);

			// Zeiger auf das Paar danach
			nPaarDanach[nPaarDanachIndex] = nPaarDavor[nPaarDavorIndex];
         
			// Zeiger auf das Paar davor
			nPaarDavor[nPaarDavorIndex] = nPaarDanachIndex;

			// Anzahl der Treffer von diesem Paars erhhen
			nPaarTreffer[nPaarDavorIndex]++;

			// Erste Zeile ist gleich zweiter Zeile
			nZeileA = nZeileB;
		}
    }

	for(nZeilenIndex=0; nZeilenIndex<KOMBINATIONEN; nZeilenIndex++)
		nPaarNummer[nZeilenIndex] = 0;

	nPaarIndexAnzahl = 0;
	do
	{
		// Das Paar mit den meisten Treffern suchen
		nMaxTreffer = 0;
		nPaarDavorIndex = 0;
		for(nZeilenIndex=0; nZeilenIndex<ZEILENZAHL*ZEILENZAHL; nZeilenIndex++)
		{
			if(nPaarTreffer[nZeilenIndex] > nMaxTreffer)
			{
				nMaxTreffer = nPaarTreffer[nZeilenIndex];
				nPaarDavorIndex = nZeilenIndex;
			}
		}

		// Wenn das Paar benutzt wird dann merken
		nTreffer = PaarBewerten(nPaarDavorIndex);
		if(nTreffer > 0)
		{
			nCount += nTreffer;
			PaarMerken(nPaarDavorIndex);
		}

		nPaarTreffer[nPaarDavorIndex] = 0;
	}
	while(nCount < KOMBINATIONEN*nTestzeilen);

	nPaarIndexLOW=0xffff;
	nPaarIndexHIGH=0x0000;

	for ( nCount = 0 ; nCount < nPaarIndexAnzahl ; nCount++ )
	{
		if ( nPaarIndexA[nCount] < nPaarIndexLOW ) nPaarIndexLOW=nPaarIndexA[nCount];
		if ( nPaarIndexB[nCount] < nPaarIndexLOW ) nPaarIndexLOW=nPaarIndexB[nCount];
		if ( nPaarIndexA[nCount] > nPaarIndexHIGH ) nPaarIndexHIGH=nPaarIndexA[nCount];
		if ( nPaarIndexB[nCount] > nPaarIndexHIGH ) nPaarIndexHIGH=nPaarIndexB[nCount];
	}
   
	free(nPaarNummer);
	free(nPaarTreffer);
	free(nPaarDavor);
	free(nPaarDanach);
	return(TRUE);
}


void BerechnePermutation(int   nKey,int *pZeilen)
{
	int   nStartwert = nKey>>7;
	int   nSchrittweite = (nKey&0x7f)*2+1;
	int   nZeile;
	int   nBuffer[32];
	//
	// Diese Funktion berechnet die Zeilenpermutation fr eine Kombination 
	// aus nStartwert und nSchrittweite.
	//
	for(nZeile=0; nZeile<32; nZeile++)
		nBuffer[nZeile] = nZeile;

	for(nZeile=0; nZeile<ZEILENZAHL-32; nZeile++)
	{
		pZeilen[nZeile] = nBuffer[pKeys[nStartwert]];
		nBuffer[pKeys[nStartwert]] = nZeile+32;
		nStartwert += nSchrittweite;
		nStartwert &= 0xff;
	}

	for(nZeile=0;nZeile<32;nZeile++)
		pZeilen[nZeile+ZEILENZAHL-32] = nBuffer[nZeile];

}


void FindYUVLineOrder(short **pLinesAddress ,int *pSortLines, int  *nPALplusZeile,int  *nPALplusData)
{
	short *pTestPixelptr = &pTestPixel_firstfield[nPaarIndexLOW][0];
	short *m1,*m2;
	unsigned int nKorrelation;
	int j=0;

	if(PalPlusActive)//Grincheux
		*nPALplusZeile = FindePALplus(pLinesAddress, nPALplusData);
	else *nPALplusZeile=-1;//Grincheux

	if (( Line0BlackEven == TRUE ) || (FirstWidthEven > 3 ) || ( Line1BlackEven == TRUE ) || ( Line285BlackEven == TRUE ) || ( Line286BlackEven == TRUE ))
	{
		Black_Matrix(pLinesAddress, &j, &BLData,&MatrixKey,FirstWidthEven,UntilEven);
		if (( BLData == 1) && (*nPALplusZeile < 0 ))
		{
			*nPALplusZeile =j;
		}
	}
	else
	{
		BLData=0;
		FirstWidthEven=0;
	}

	_asm
	{
		movq  mm4,qword ptr[nMaske] 
		mov   edx,nPaarIndexLOW
		mov   eax,pLinesAddress
		mov   edi,dword ptr [eax+4*edx]
		mov   eax,pTestPixelptr
		mov   esi,eax
		mov   ecx,4
		mov   eax,nPixelSchritt
		mov   ebx,eax
		shr   eax,1
		movd  mm1,eax
		jmp   MoreToGet
	NextLine:
		mov   ecx,4
		mov   edi,dword ptr [eax+4*edx]
		movd  eax,mm1
	MoreToGet: 
		movq  mm0,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm0,mm4
		movq  mm3,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm3,mm4
		movq  mm5,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm5,mm4
		movq  mm6,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm6,mm4
		packuswb mm0,mm3
		packuswb mm5,mm6
		movq  mm3,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm3,mm4
		movq  mm6,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm6,mm4
		movq  mm7,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm7,mm4
		packuswb mm3,mm6
		movq  mm6,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm6,mm4
		packuswb mm6,mm7
		movq  qword ptr [esi],mm0
		movq  qword ptr [esi+8],mm3
		movq  qword ptr [esi+16],mm5
		movq  qword ptr [esi+24],mm6
		add   esi,32
		loop  MoreToGet
		inc   edx
		mov   eax,pLinesAddress
		cmp   edx,nPaarIndexHIGH
		jle    NextLine
	}

	for(j=0; j<nPaarIndexAnzahl; j++)
	{
		m1=&pTestPixel_firstfield[nPaarIndexA[j]][0];
		m2=&pTestPixel_firstfield[nPaarIndexB[j]][0];
		_asm
		{
 			mov        ecx, 0x10
			mov        edx, m1
			mov        ebx, m2
			pxor       mm7, mm7
			pxor       mm4, mm4
	
		NextQuadPixel:
			movq       mm0, qword ptr [edx+8*ecx-8] 
			movq       mm2, mm0  
			
			movq       mm1, qword ptr [edx+8*ecx-16]
			movq       mm3, mm1
	
			movq       mm5, qword ptr [ebx+8*ecx-8] 
	
			movq       mm6, qword ptr [ebx+8*ecx-16] 
			psubusb    mm0, mm5

			dec        ecx
			psubusb    mm1, mm6 
		
			psubusb    mm5, mm2
			psubusb    mm6, mm3

			por        mm0,mm5
			por        mm1,mm6

			movq       mm2,mm0
			movq       mm3,mm1

			punpckhbw  mm0,mm4
			dec ecx

			punpckhbw  mm1,mm4
			//paddw      mm7, mm0 snabrab : Bug la ligne doit tre plus bas (sommation ppartielle)

			punpcklbw  mm2,mm4
			paddw      mm0,mm1

			punpcklbw  mm3,mm4
			paddw      mm7, mm0 //snabrab  ligne doit tre aprs "paddw mm0,mm1" (sommation totale)

			paddw      mm2,mm3

			paddw      mm7, mm2
			jnz NextQuadPixel
        
			pmaddwd	   mm7,qword ptr[One] 
			movq       mm0, mm7
			psrlq      mm7, 32 
			paddd      mm7, mm0	
			movd       nKorrelation,mm7
			emms
		}
		nZeilenPaarKorrelation[j] = nKorrelation;
	}

	if ( *nPALplusZeile >= 0 )
	{
		if (MatrixModeEven) BerechnePermutation(SucheKeyPalPlusMatrix(*nPALplusZeile,MatrixKey,0) , pSortLines); 
		else if  ((Line1BlackEven) || (Line285BlackEven) || (Line286BlackEven))	BerechnePermutation(SucheKeyPalPlusMore(*nPALplusZeile,Line1BlackEven,Line285BlackEven,Line286BlackEven) , pSortLines);  
		else BerechnePermutation(SucheKeyPalPlus(*nPALplusZeile) , pSortLines);
	}
	else
	{
		if (MatrixModeEven) BerechnePermutation(SucheKeyBlackMatrix(MatrixKey,0) , pSortLines); 
		else if  ((Line1BlackEven) || (Line285BlackEven) || (Line286BlackEven))	BerechnePermutation(SucheKeyBlackMore(Line1BlackEven,Line285BlackEven,Line286BlackEven) , pSortLines);
		else BerechnePermutation(SucheKeyBlack() , pSortLines);
	}
}


void FindYUVSecondLineOrder(short **pLinesAddress ,int *pSortLines)
{
	short *pTestPixelptr = &pTestPixel_firstfield[nPaarIndexLOW][0];
	short *m1,*m2;
	unsigned int nKorrelation;
	int j;
	int mp;

	mp=-1;
	if (( Line0BlackOdd == TRUE ) || (FirstWidthOdd > 3 ) || ( Line1BlackOdd == TRUE ) || ( Line285BlackOdd == TRUE ) || ( Line286BlackOdd == TRUE ))
	{
		Black_Matrix(pLinesAddress, &j, &BLData,&MatrixKey,FirstWidthOdd,UntilOdd);
		if ( Line0BlackOdd == FALSE )  BLData=0;
		if ( BLData==1 ) mp =j; 
	}
	else
	{
		BLData=0;
		FirstWidthOdd=0;
	}

	_asm
	{
		movq  mm4,qword ptr[nMaske] 
		mov   edx,nPaarIndexLOW
		mov   eax,pLinesAddress
		mov   edi,dword ptr [eax+4*edx]
		mov   eax,pTestPixelptr
		mov   esi,eax
		mov   ecx,4
		mov   eax,nPixelSchritt
		mov   ebx,eax
		shr   eax,1
		movd  mm1,eax
		jmp   MoreToGet
	NextLine:
		mov   ecx,4
		mov   edi,dword ptr [eax+4*edx]
		movd  eax,mm1
	MoreToGet: 
		movq  mm0,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm0,mm4
		movq  mm3,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm3,mm4
		movq  mm5,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm5,mm4
		movq  mm6,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm6,mm4
		packuswb mm0,mm3
		packuswb mm5,mm6
		movq  mm3,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm3,mm4
		movq  mm6,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm6,mm4
		movq  mm7,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm7,mm4
		packuswb mm3,mm6
		movq  mm6,qword ptr [edi+4*eax];
		add   eax,ebx
		pand  mm6,mm4
		packuswb mm6,mm7
		movq  qword ptr [esi],mm0
		movq  qword ptr [esi+8],mm3
		movq  qword ptr [esi+16],mm5
		movq  qword ptr [esi+24],mm6
		add   esi,32
		loop  MoreToGet
		inc   edx
		mov   eax,pLinesAddress
		cmp   edx,nPaarIndexHIGH
		jle    NextLine
	}

	for(j=0; j<nPaarIndexAnzahl; j++)
	{
		m1=&pTestPixel_firstfield[nPaarIndexA[j]][0];
		m2=&pTestPixel_firstfield[nPaarIndexB[j]][0];

		_asm 
		{
 			mov        ecx, 0x10
			mov        edx, m1
			mov        ebx, m2
			pxor       mm7, mm7
			pxor       mm4, mm4
	
		NextQuadPixel:
			movq       mm0, qword ptr [edx+8*ecx-8] 
			movq       mm2, mm0
	
			movq       mm1, qword ptr [edx+8*ecx-16]
			movq       mm3, mm1             
	
			movq       mm5, qword ptr [ebx+8*ecx-8] 
	
			movq       mm6, qword ptr [ebx+8*ecx-16] 
			psubusb    mm0, mm5             
	
			dec        ecx
			psubusb    mm1, mm6
			
			psubusb    mm5, mm2
			psubusb    mm6, mm3
	
			por        mm0,mm5
			por        mm1,mm6

			movq       mm2,mm0
			movq       mm3,mm1

			punpckhbw  mm0,mm4
			dec ecx

			punpckhbw  mm1,mm4
			//paddw      mm7, mm0 //snabrab : Bug la ligne doit tre plus bas (sommation ppartielle)

			punpcklbw  mm2,mm4
			paddw      mm0,mm1

			punpcklbw  mm3,mm4
			paddw      mm7, mm0 //snabrab  ligne doit tre aprs "paddw mm0,mm1" (sommation totale)

			paddw      mm2,mm3

	        paddw      mm7, mm2
			jnz NextQuadPixel
        
			pmaddwd	   mm7,qword ptr[One] 
			movq       mm0, mm7
			psrlq      mm7, 32 
			paddd      mm7, mm0	
			movd       nKorrelation,mm7
			emms
		}
		nZeilenPaarKorrelation[j] = nKorrelation;
	}

	if ( mp >= 0 )
	{
		if (MatrixModeOdd) BerechnePermutation(SucheKeyPalPlusMatrix(mp,MatrixKey,1) , pSortLines); 
		else if((Line1BlackOdd) || (Line285BlackOdd) || (Line286BlackOdd))	BerechnePermutation(SucheKeyPalPlusMore(mp,Line1BlackOdd,Line285BlackOdd,Line286BlackOdd) , pSortLines);  
        else BerechnePermutation(SucheKeyPalPlus(mp) , pSortLines);

				  
	}
	else
	{
		if (MatrixModeOdd) BerechnePermutation(SucheKeyBlackMatrix(MatrixKey,1) , pSortLines); 
		else if((Line1BlackOdd) || (Line285BlackOdd) || (Line286BlackOdd))	BerechnePermutation(SucheKeyBlackMore(Line1BlackOdd,Line285BlackOdd,Line286BlackOdd) , pSortLines);
		else BerechnePermutation(SucheKeyBlack() , pSortLines);
	}
}


int FindePALplus(short **pLinesAddress,int  *nPALplusData)
{
	int      nBit;
	int      nPixel;
	int      nZeile ;
	int      nOffset;
	short   *pLine;

	// Daten initialisieren
	*nPALplusData = 0;
	// Die 32 mglichen Zeilen durchsuchen
	for(nZeile=0; nZeile<32; nZeile++)
	{  
		pLine = (short*)&pLinesAddress[nZeile][0];

		// Auf das Startbit warten
		nOffset = 0;
		for(nPixel=0; nPixel<20*CurrentX/768; nPixel++)
		{
			// Startbit gefunden
			if((*(pLine+nOffset)&0xff) > nLevelHigh)
	            break;
         
			// Abstand Zeilenanfang bis Startbit
			nOffset++;
		}

		// Bitcode berprfen
		for(nPixel=0; nPixel<14; nPixel+=2)
		{
			if((*(pLine+nOffset+pPALplusCode[nPixel]*CurrentX/768)&0xff) > nLevelLow)
			break;

			if((*(pLine+nOffset+pPALplusCode[nPixel+1]*CurrentX/768)&0xff) < nLevelHigh)
			break;
		}
		// Wenn alle 7 Bit richtig sind dann wurde die Zeile gefunden
		if(nPixel == 14)
		{  
			// Daten auslesen
			nBit = 0x0001;

			for(nPixel=0; nPixel<14; nPixel++)
			{

				if((*(pLine+nOffset+pPALplusData[nPixel]*CurrentX/768)&0xff) > nLevelHigh)
					*nPALplusData |= nBit;
				nBit <<= 1;
			}

			return nZeile;
		}
    }

 	// Zeile nicht gefunden
	return -1;
}


void Black_Matrix(short **pLinesAddress, int *OneLine, int *Count ,unsigned int *MatrixKey,int FirstWidth,int Until)
{
	int AnzahlSchwarzeZeilen=0;
	const __int64  ShiftAdd = 0x0000000080000000;

	_asm
	{
	    push    edi
		push    esi
		movq  mm5,qword ptr[CurrentLowValue]
		movq  mm4,qword ptr[nMaske] 
		movq  mm6,qword ptr[ShiftAdd]
		xor   edx,edx
		mov   dword ptr BlackSet[edx*4],0
		mov   eax,pLinesAddress
		mov   edi,dword ptr [eax+4*edx]
		mov   ecx,FirstWidth
		movd  mm7,ecx
		mov   eax,nPixelSchritt
		shr   eax,1
		mov   esi,eax
		jmp   MoreToGet

	NextLine:
		mov   dword ptr BlackSet[edx*4],0
		mov   eax,pLinesAddress
		movd  ecx,mm7
		mov   edi,dword ptr [eax+4*edx]
		mov   eax,esi
	
	MoreToGet: 
		movq  mm0,qword ptr [edi+4*eax];
		pand  mm0,mm4
		psubusb  mm0,mm5   
		add   eax,nPixelSchritt
		packsswb mm0,mm0
		movd   ebx,mm0
		cmp    ebx,0
		jnz    NichtSchwarz
		loop   MoreToGet
		mov    dword ptr BlackSet[edx*4],1
		inc   AnzahlSchwarzeZeilen
		mov   ebx,dword ptr [OneLine]
		mov   dword ptr [ebx],edx 
			   
	NichtSchwarz:
		inc   edx
		cmp   edx,32
		jl    NextLine
		mov   ebx,dword ptr [Count]
		mov   ecx,AnzahlSchwarzeZeilen
		mov   dword ptr [ebx],ecx 

		cmp   Until,1
		jz    Ende 

	// Next 32 fr MatrixKey
		mov   ecx,0x10
		pxor  mm3,mm3
		mov   dword ptr BlackSet[edx*4],0
		mov   eax,pLinesAddress
		mov   edi,dword ptr [eax+4*edx]
		mov   eax,esi
		jmp   MoreToGet1
	
	NextLine1:
		psrld mm3,1 
		mov   dword ptr BlackSet[edx*4],0
		mov   eax,pLinesAddress
		mov   ecx,0x10
		mov   edi,dword ptr [eax+4*edx]
		mov   eax,esi
		
	MoreToGet1: 
		movq  mm0,qword ptr [edi+4*eax];
		add   eax,nPixelSchritt
		pand  mm0,mm4
		psubusb  mm0,mm5   
		add   eax,nPixelSchritt
		packsswb mm0,mm0
		movd   ebx,mm0
		cmp    ebx,0
		jnz    NichtSchwarz1
		loop   MoreToGet1
		paddw mm3,mm6
		mov    dword ptr BlackSet[edx*4],1
			   
	NichtSchwarz1:
		inc   edx
		cmp   edx,64
		jl    NextLine1
		mov   eax,dword ptr [MatrixKey];
		movd  dword ptr [eax],mm3
		
	// Rest
		mov   dword ptr BlackSet[edx*4],0
   		mov   ecx,0x10
		mov   eax,pLinesAddress
		mov   edi,dword ptr [eax+4*edx]
		mov   eax,esi
		jmp   MoreToGet2

	NextLine2:
		mov   dword ptr BlackSet[edx*4],0
		mov   eax,pLinesAddress
		mov   ecx,0x10
		mov   edi,dword ptr [eax+4*edx]
		mov   eax,esi
			   
	MoreToGet2: 
		movq  mm0,qword ptr [edi+4*eax];
		add   eax,nPixelSchritt
		pand  mm0,mm4
		psubusb  mm0,mm5   
		add   eax,nPixelSchritt
		packsswb mm0,mm0
		movd   ebx,mm0
		cmp    ebx,0
		jnz    NichtSchwarz2
		loop   MoreToGet2
		mov    dword ptr BlackSet[edx*4],1
			   
	NichtSchwarz2:
		inc   edx
		cmp   edx,287
		jl    NextLine2

	Ende:
	    pop esi
		pop edi
		emms
    }
}


int FindePalPlusZeile(short *pLine,int  *nPALplusData)
{
	int      nBit;
	int      nPixel;
	int      nZeile=-1;
	int      nOffset;

	// Daten initialisieren
	*nPALplusData = 0;
	// Die 32 mglichen Zeilen durchsuchen
	// Auf das Startbit warten
    nOffset = 0;
    for(nPixel=0; nPixel<20*CurrentX/768; nPixel++)
	//      for(nPixel=0; nPixel<20; nPixel++)
    {
		// Startbit gefunden
		if((*(pLine+nOffset)&0xff) > nLevelHigh)
			break;
         
		// Abstand Zeilenanfang bis Startbit
        nOffset++;
	}

    // Bitcode berprfen
    for(nPixel=0; nPixel<14; nPixel+=2)
    {
		// Fr andere horizontale Auflsungen als 384, Pixelabstand angleichen
		//         if((*(pLine+nOffset+pPALplusCode[nPixel]*m_nBreiteQuelle/768)&0xff) > nLow)
        if((*(pLine+nOffset+pPALplusCode[nPixel]*CurrentX/768)&0xff) > nLevelLow)
			break;

		//         if((*(pLine+nOffset+pPALplusCode[nPixel+1]*m_nBreiteQuelle/768)&0xff) < nHigh)
		if((*(pLine+nOffset+pPALplusCode[nPixel+1]*CurrentX/768)&0xff) < nLevelHigh)
			break;
	}
    // Wenn alle 7 Bit richtig sind dann wurde die Zeile gefunden
    if(nPixel == 14)
    {  
		// Daten auslesen
        nBit = 0x0001;
        for(nPixel=0; nPixel<14; nPixel++)
        {
			//            if((*(pLine+nOffset+pPALplusData[nPixel]*m_nBreiteQuelle/768)&0xff) > nHigh)
			if((*(pLine+nOffset+pPALplusData[nPixel]*CurrentX/768)&0xff) > nLevelHigh)
				*nPALplusData |= nBit;
            nBit <<= 1;
		}
        return nZeile;
	}
	return -1;
}


BOOL LeseIndexDatei()
{
	FILE *sFile;
	int fd;
	unsigned int nbytes;

	// Datei mit vorberechneten Tabellen einlesen
	char pDateiName[255];

	// Dateiname erzeugen
	sprintf(pDateiName, "%sGoldorak%d.%s", PLUGIN_SUBDIR, nTestzeilen,Idefix);

	// Datei zum Lesen ffnen
	sFile = fopen(pDateiName, "rb");

	// Wenn die Datei nicht vorhanden ist, Tabellen neu berechnen
	if(sFile == NULL)
		return(FALSE);

	fd = open(pDateiName, _O_RDONLY | _O_BINARY);
    if ( fd < 0 )
	{
 		fclose(sFile);
		return(FALSE);
	}
	nbytes=_filelength(fd);
    close(fd);
   
	if(fread(&nPaarIndexAnzahl, sizeof(int), 1, sFile) != 1)
	{
		fclose(sFile);
		return (FALSE);
    }

	if ( (signed)nbytes != 12+(8*nPaarIndexAnzahl)+(KOMBINATIONEN*MoreTestZeilen*2) )
	{
		fclose(sFile);
		return (FALSE);
	}

	nPaarIndexA    = (int *)calloc(nPaarIndexAnzahl,sizeof(int));
	nPaarIndexB    = (int *)calloc(nPaarIndexAnzahl,sizeof(int));

	if(fread(&nPaarIndexLOW, sizeof(int), 1, sFile) != 1)
	{
		fclose(sFile);
		return FALSE;
    }
	if(fread(&nPaarIndexHIGH, sizeof(int), 1, sFile) != 1)
	{
		fclose(sFile);
		return FALSE;
    }
	// Daten einlesen      
	if(fread(pKombinationen, sizeof(unsigned short), KOMBINATIONEN*MoreTestZeilen, sFile) != (size_t)(KOMBINATIONEN*MoreTestZeilen))
	{
		fclose(sFile);
		return (FALSE);
    }

	if(fread(nPaarIndexA, sizeof(int), nPaarIndexAnzahl, sFile) !=(size_t) nPaarIndexAnzahl)
	{
		fclose(sFile);
		return (FALSE);
	}

	if(fread(nPaarIndexB, sizeof(int), nPaarIndexAnzahl, sFile) !=(size_t) nPaarIndexAnzahl)
	{
		fclose(sFile);
		return (FALSE);
	}
	fclose(sFile);
	return (TRUE);
}


int PaarBewerten(int nPaarDavorIndex)
{
	int nKey;
	int nTreffer = 0;
	int nNaechstesPaarIndex = nPaarDavor[nPaarDavorIndex];

	while(nNaechstesPaarIndex != -1)
	{
		nKey = nNaechstesPaarIndex/nAnzahlPaare;

		if(nPaarNummer[nKey] < nTestzeilen)
			nTreffer++;

		nNaechstesPaarIndex = nPaarDanach[nNaechstesPaarIndex];
    }
	return nTreffer;
}


void PaarMerken(int nPaarDavorIndex)
{
	int nNaechstesPaarIndex;
	int nKey;
	int q;
	int nZeileA;
	int nZeileB;
	int nb;

	nZeileA = nPaarDavorIndex / ZEILENZAHL;
	nZeileB = nPaarDavorIndex % ZEILENZAHL;
	nPaarIndexA[nPaarIndexAnzahl] = nZeileA;
	nPaarIndexB[nPaarIndexAnzahl] = nZeileB;
 
	nNaechstesPaarIndex = nPaarDavor[nPaarDavorIndex];
	while(nNaechstesPaarIndex != -1)
	{
		nKey = nNaechstesPaarIndex/nAnzahlPaare;
		nb = nPaarNummer[nKey]++;
		q = nPaarDanach[nNaechstesPaarIndex];
		
		if(nb < nTestzeilen)
		{
			pKombinationen[MoreTestZeilen*nKey+nb+7] = (unsigned short)nPaarIndexAnzahl;
		}
		nNaechstesPaarIndex = q;
	}

	nPaarIndexAnzahl++;
}


BOOL SchreibeIndexDatei()
{
	FILE *sFile;
	char temperr[] = "Le fichier Index ne peut tre cr";
	// Vorberechneten Tabellen in Datei schreiben
	char pDateiName[255];
	// Dateiname erzeugen

	sprintf(pDateiName, "%sGoldorak%d.%s", PLUGIN_SUBDIR, nTestzeilen,Idefix);
	CreateDirectory( PLUGIN_SUBDIR, (LPSECURITY_ATTRIBUTES)NULL);	

	// Datei zum Schreiben ffnen
	sFile = fopen(pDateiName, "wb");

	if(sFile == NULL)
	{
		ErreurFatale(temperr);
		return FALSE;
	}

	if(fwrite(&nPaarIndexAnzahl, sizeof(int), 1, sFile) != 1)
    {
		ErreurFatale(temperr);
		fclose(sFile);
		remove(pDateiName);
		return FALSE;
	}

	if(fwrite(&nPaarIndexLOW, sizeof(int), 1, sFile) != 1)
	{
		ErreurFatale(temperr);
		fclose(sFile);
		remove(pDateiName);
		return FALSE;
	}
   
	if(fwrite(&nPaarIndexHIGH, sizeof(int), 1, sFile) != 1)
	{
		ErreurFatale(temperr);
		fclose(sFile);
		remove(pDateiName);
		return FALSE;
	}

	if(fwrite(pKombinationen, sizeof(unsigned short), KOMBINATIONEN*MoreTestZeilen, sFile) != (size_t)KOMBINATIONEN*MoreTestZeilen)
	{
		ErreurFatale(temperr);
		fclose(sFile);
	    remove(pDateiName);
		return FALSE;
	}

	if(fwrite(nPaarIndexA, sizeof(int), nPaarIndexAnzahl, sFile) != (size_t)nPaarIndexAnzahl)
	{
		ErreurFatale(temperr);
		fclose(sFile);
		remove(pDateiName);
		return FALSE;
	}

	if(fwrite(nPaarIndexB, sizeof(int), nPaarIndexAnzahl, sFile) != (size_t)nPaarIndexAnzahl)
	{
		ErreurFatale(temperr);
		fclose(sFile);
		remove(pDateiName);
		return FALSE;
	}

	fclose(sFile);
// desactiv pour le passage  la DLL - 18/6/2001
//	DisplayStatusBar("Ecriture Index");
	return TRUE;
}


int SucheKeyPalPlus(  int   nPalPlusZeile )
{
	int      nBesterKandidat=0;
	int      nStartwert=0;
	int      nSchrittweite=0;
	int      mt=MoreTestZeilen*2;
	int      mts=mt*128;
	int      nt=nTestzeilen/2;

	__asm
	{
		mov edi,pKombinationen
        add edi,14
        mov esi,0x0fffffff
	InitLoopMitPalPlus:
        mov eax,nStartwert
		mov edx,nPalPlusZeile
		cmp edx,0
		jl  Init_Correl_2
	LoopMitPalPlus:  
		movsx ecx, byte ptr pKeys[eax]
		cmp ecx,edx
        je  Init_Correl
        add edi,mts
		inc eax
		cmp eax,256
		jz Ende
		jmp LoopMitPalPlus

	Init_Correl:
        mov nStartwert,eax

	Init_Correl_2:
        mov nSchrittweite,0

	Do_Correl:
		xor ecx,ecx
        xor eax,eax

	SchrittLoop:
        mov ebx,dword ptr [edi+4*ecx]
        mov edx,ebx
		and ebx,0x0000ffff;
		shr edx,16
		add eax,dword ptr nZeilenPaarKorrelation[4*ebx]
		add eax,dword ptr nZeilenPaarKorrelation[4*edx]
        inc   ecx
		cmp eax,esi
		jge  ZuViel
        cmp ecx,nt
		jl  SchrittLoop
		mov esi,eax
        mov ebx,nSchrittweite
		mov eax,nStartwert
		shl eax,7
		add eax,ebx
		mov nBesterKandidat,eax

	ZuViel:
        add edi,mt
        inc nSchrittweite
		cmp nSchrittweite,128
		jl Do_Correl
        inc nStartwert
		cmp nStartwert,256
		jl InitLoopMitPalPlus
	Ende:   
    }
	return (nBesterKandidat);
}


int SucheKeyBlack(  )
{
	int      nBesterKandidat=0;
	int      nStartwert=0;
	int      nSchrittweite=0;
	int      nt=nTestzeilen/2;
	int      mt=MoreTestZeilen*2;
	int      mts=mt*128;

	__asm
	{
		mov edi,pKombinationen
        mov esi,0x0fffffff
        add edi,14

	InitLoopMitSchwarz:
        mov eax,nStartwert
		cmp BLData,0
		jle Init_Correl_2

	LoopMitSchwarz:  
		movsx ecx, byte ptr pKeys[eax]
        cmp dword ptr BlackSet[4*ecx],1
        je  Init_Correl
        add edi,mts
		inc eax
		cmp eax,256
		jz Ende
		jmp LoopMitSchwarz

	Init_Correl:
        mov nStartwert,eax

	Init_Correl_2:
        mov nSchrittweite,0

	Do_Correl:
		xor ecx,ecx
        xor eax,eax

	SchrittLoop:
        mov ebx,dword ptr [edi+4*ecx]
        mov edx,ebx
		and ebx,0x0000ffff;
		shr edx,16
        inc   ecx
		add eax,dword ptr nZeilenPaarKorrelation[4*ebx]
		add eax,dword ptr nZeilenPaarKorrelation[4*edx]
		cmp eax,esi
		jge  ZuViel
        cmp ecx,nt
		jl  SchrittLoop
		mov esi,eax
        mov ebx,nSchrittweite
		mov eax,nStartwert
		shl eax,7
		add eax,ebx
		mov nBesterKandidat,eax

	ZuViel:
		add edi,mt
        inc nSchrittweite
		cmp nSchrittweite,128
		jl Do_Correl
        inc nStartwert
		cmp nStartwert,256
		jl InitLoopMitSchwarz 

	Ende:   
	}
	return (nBesterKandidat);
}


int SucheKeyPalPlusMatrix( int   nPalPlusZeile,unsigned int MatrixKey ,int evenodd)
{
	int      nBesterKandidat=0;
	int      nStartwert=0;
	int      nSchrittweite=0;
	int      mt=MoreTestZeilen*2;
	int      mts=MoreTestZeilen*256;
	int      nt=nTestzeilen/2;

	__asm
	{
		mov esi,0x0fffffff
	    mov edi,pKombinationen

	InitLoopMitPalPlus:
        mov eax,nStartwert
		mov edx,nPalPlusZeile
		cmp edx,0
		jl  Init_Correl_2

	LoopMitPalPlus:  
		movsx ecx, byte ptr pKeys[eax]
		cmp ecx,edx
        je  Init_Correl
		inc eax
        add edi,mts
		cmp eax,256
		jz Ende
		jmp LoopMitPalPlus

	Init_Correl:
        mov nStartwert,eax
	
	Init_Correl_2:
        mov nSchrittweite,0
	
	Do_Correl:
		mov ebx,MatrixKey
        mov eax,evenodd

	NextMatrix:
        mov ecx,dword ptr [edi+eax*4]
        mov edx,ebx
		xor edx,ecx
		and ecx,edx
        cmp ecx,0            
        je  Start_Correl
        add edi,mt          
        inc nSchrittweite
		cmp nSchrittweite,128
        jl NextMatrix
        inc nStartwert
		cmp nStartwert,256
		jl  InitLoopMitPalPlus
		jmp Ende
        
	Start_Correl:
        xor ecx,ecx
        xor eax,eax
	
	SchrittLoop:
        mov ebx,dword ptr [edi+4*ecx+14]
        mov edx,ebx
		and ebx,0x0000ffff;
		shr edx,16
		add eax,dword ptr nZeilenPaarKorrelation[4*ebx]
		add eax,dword ptr nZeilenPaarKorrelation[4*edx]
        inc   ecx
		cmp eax,esi
		jge ZuViel
        cmp ecx,nt
		jl SchrittLoop
		mov esi,eax
        mov ebx,nSchrittweite
		mov eax,nStartwert
		shl eax,7
		add eax,ebx
		mov nBesterKandidat,eax
	ZuViel:
		add edi,mt
        inc nSchrittweite
		cmp nSchrittweite,128
		jl Do_Correl
        inc nStartwert
		cmp nStartwert,256
		jl InitLoopMitPalPlus
	Ende:   
    }
	return nBesterKandidat;
}


int SucheKeyPalPlusMore( int   nPalPlusZeile,BOOL Black1,BOOL Black285,BOOL Black286 )
{
	int      nBesterKandidat=0;
	int      nStartwert=0;
	int      nt=nTestzeilen/2;
	int      nSchrittweite=0;
	int      mt=MoreTestZeilen*2;
	int      mts=MoreTestZeilen*256;

	__asm
	{
		mov esi,0x0fffffff
	    mov edi,pKombinationen

	InitLoopMitPalPlus:
		mov eax,nStartwert
		mov edx,nPalPlusZeile
		cmp edx,0
		jl  Init_Correl_2

	LoopMitPalPlus:  
		movsx ecx, byte ptr pKeys[eax]
		cmp ecx,edx
        je  Init_Correl
		inc eax
        add edi,mts
		cmp eax,256
		jz Ende
		jmp LoopMitPalPlus

	Init_Correl:
        mov nStartwert,eax

	Init_Correl_2:
        mov nSchrittweite,0

	NextBlackSet:
        cmp Black1,1
        jnz TestBlack2
        movsx ebx,word ptr [edi+8]
        cmp dword ptr BlackSet[4*ebx],0
		jz FalschesBlackSet 

	TestBlack2:
        cmp Black286,1
        jnz TestBlack3
        movsx ebx,word ptr [edi+10]
        cmp dword ptr BlackSet[4*ebx],0
		jz FalschesBlackSet 

	TestBlack3:
        cmp Black285,1
        jnz Start_Correl
        movsx ebx,word ptr [edi+12]
        cmp dword ptr BlackSet[4*ebx],0
		jz FalschesBlackSet 
    	jmp  Start_Correl

	FalschesBlackSet: 
        add edi,mt          
        inc nSchrittweite
		cmp nSchrittweite,128
        jl NextBlackSet
        inc nStartwert
		cmp nStartwert,256
		jl  InitLoopMitPalPlus
		jmp Ende
        
	Start_Correl:
        xor ecx,ecx
        xor eax,eax

	SchrittLoop:
        mov ebx,dword ptr [edi+4*ecx+14]
        mov edx,ebx
		and ebx,0x0000ffff;
		shr edx,16
		add eax,dword ptr nZeilenPaarKorrelation[4*ebx]
		add eax,dword ptr nZeilenPaarKorrelation[4*edx]
        inc   ecx
		cmp eax,esi
		jge ZuViel
        cmp ecx,nt
		jl SchrittLoop
		mov esi,eax
        mov ebx,nSchrittweite
		mov eax,nStartwert
		shl eax,7
		add eax,ebx
		mov nBesterKandidat,eax

	ZuViel:
		add edi,mt
        inc nSchrittweite
		cmp nSchrittweite,128
		jl NextBlackSet
        inc nStartwert
		cmp nStartwert,256
		jl InitLoopMitPalPlus
	Ende:   
	}
	return (nBesterKandidat);
}


int SucheKeyBlackMatrix(unsigned int MatrixKey,int evenodd )
{
	int      nBesterKandidat=0;
	int      nt=nTestzeilen/2;
	int      mt=MoreTestZeilen*2;
	int      mts=mt*128;
	int      nStartwert=0;
	int      nSchrittweite=0;

	__asm
	{
		mov esi,0x0fffffff
	    mov edi,pKombinationen

	InitLoopMitSchwarz:
        mov eax,nStartwert
		cmp BLData,0
		jle Init_Correl_2
	
	LoopMitSchwarz:  
		movsx ecx, byte ptr pKeys[eax]
        cmp dword ptr BlackSet[4*ecx],1
        je  Init_Correl
        inc eax
		add edi,mts
		cmp eax,256
		jz Ende
		jmp LoopMitSchwarz

	Init_Correl:
        mov nStartwert,eax

	Init_Correl_2:
        mov nSchrittweite,0

	Do_Correl:
		mov ebx,MatrixKey
        mov eax,evenodd
	
	NextMatrix:
        mov ecx,dword ptr [edi+eax*4]
        mov edx,ebx
		xor edx,ecx
		and ecx,edx
        cmp  ecx,0
        je  Start_Correl
        inc nSchrittweite
        add edi,mt          
		cmp nSchrittweite,128
        jl NextMatrix
        inc nStartwert
		cmp nStartwert,256
		jl  InitLoopMitSchwarz
		jmp Ende
          
	Start_Correl:
        xor  ecx,ecx
		xor  eax,eax
		  
	SchrittLoop:
        mov ebx,dword ptr [edi+4*ecx+14]
        mov edx,ebx
		and ebx,0x0000ffff;
		shr edx,16
		add eax,dword ptr nZeilenPaarKorrelation[4*ebx]
		add eax,dword ptr nZeilenPaarKorrelation[4*edx]
        inc   ecx
		cmp eax,esi
		jge ZuViel
        cmp ecx,nt
		jl SchrittLoop
		mov esi,eax
        mov ebx,nSchrittweite
		mov eax,nStartwert
		shl eax,7
		add eax,ebx
		mov nBesterKandidat,eax

	ZuViel:
		add edi,mt
        inc nSchrittweite
		cmp nSchrittweite,128
		jl Do_Correl
        inc nStartwert
		cmp nStartwert,256
		jl InitLoopMitSchwarz

	Ende:   
	}
	return nBesterKandidat;
}


int SucheKeyBlackMore( BOOL Black1,BOOL Black285, BOOL Black286 )
{
	int      nBesterKandidat=0;
	int      mt=MoreTestZeilen*2;
	int      mts=mt*128;
	int      nStartwert=0;
	int      nSchrittweite=0;
	int      nt=nTestzeilen/2;
	
	__asm
	{
		mov esi,0x0fffffff
		mov edi,pKombinationen

	InitLoopMitSchwarz:
        mov eax,nStartwert
		cmp BLData,0
		jle Init_Correl_2

	LoopMitSchwarz:  
		movsx ecx, byte ptr pKeys[eax]
        cmp dword ptr BlackSet[4*ecx],1
        je  Init_Correl
		inc eax
        add edi,mts
		cmp eax,256
		jz Ende
		jmp LoopMitSchwarz

	Init_Correl:
        mov nStartwert,eax

	Init_Correl_2:
        mov nSchrittweite,0

	NextBlackSet:
        cmp Black1,1
        jnz TestBlack2
        movsx ebx,word ptr [edi+8]
        cmp dword ptr BlackSet[4*ebx],0
		jz FalschesBlackSet 

	TestBlack2:
        cmp Black286,1
        jnz TestBlack3
        movsx ebx,word ptr [edi+10]
        cmp dword ptr BlackSet[4*ebx],0
		jz FalschesBlackSet 

	TestBlack3:
        cmp Black285,1
        jnz Start_Correl
        movsx ebx,word ptr [edi+12]
        cmp dword ptr BlackSet[4*ebx],0
		jz FalschesBlackSet 
    	jmp  Start_Correl

	FalschesBlackSet: 
        add edi,mt          
        inc nSchrittweite
		cmp nSchrittweite,128
        jl NextBlackSet
        inc nStartwert
		cmp nStartwert,256
		jl  InitLoopMitSchwarz
		jmp Ende
         
	Start_Correl:
        xor ecx,ecx
		xor eax,eax

	SchrittLoop:
        mov ebx,dword ptr [edi+4*ecx+14]
        mov edx,ebx
		and ebx,0x0000ffff;
		shr edx,16
		add eax,dword ptr nZeilenPaarKorrelation[4*ebx]
		add eax,dword ptr nZeilenPaarKorrelation[4*edx]
        inc   ecx
		cmp eax,esi
		jge ZuViel
        cmp ecx,nt
		jl SchrittLoop
		mov esi,eax
        mov ebx,nSchrittweite
		mov eax,nStartwert
		shl eax,7
		add eax,ebx
		mov nBesterKandidat,eax

	ZuViel:
        inc nSchrittweite
        add edi,mt
		cmp nSchrittweite,128
		jl NextBlackSet
        inc nStartwert
		cmp nStartwert,256
		jl InitLoopMitSchwarz
		mov eax,nBesterKandidat

	Ende:   
	}
	return (nBesterKandidat);
}
