/////////////////////////////////////////////////////////////////////////////
// Bdd.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Grincheux  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>		// required for all Windows applications
#include <commctrl.h>

#include "../resource.h"
#include "general.h"

int TPix, TLow;
int TUFilter, TVFilter, TYUVFilter;

// Boite de dialogue  afficher par le client
BOOL APIENTRY AboutProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
   
	switch (message)
	{
        case WM_INITDIALOG:
			break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) 
			{
				EndDialog(hDlg,TRUE);
			}
			break;
    }
	return(FALSE);

	UNREFERENCED_PARAMETER( lParam);
}


// Boite de dialogue  afficher par le client
BOOL APIENTRY PluginSetupProc(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{
	int i,j;
	BOOL Swap=TRUE;
	static BOOL InitFullField;
	HWND hUFilterThresholdPCent = GetDlgItem( hDlg, IDC_S1 );
	HWND hVFilterThresholdPCent = GetDlgItem( hDlg, IDC_S2 );
	HWND hYUVFilterThresholdPCent = GetDlgItem( hDlg, IDC_S3 );
	HWND hPix = GetDlgItem( hDlg, IDC_S4 );

    switch (message)
	{
		case WM_INITDIALOG :
			SendMessage( hUFilterThresholdPCent, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hUFilterThresholdPCent, TBM_SETRANGEMIN, TRUE, -100 );
			SendMessage( hUFilterThresholdPCent, TBM_SETTICFREQ, 5, 0 );

			SendMessage( hVFilterThresholdPCent, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hVFilterThresholdPCent, TBM_SETRANGEMIN, TRUE, -100 );
			SendMessage( hVFilterThresholdPCent, TBM_SETTICFREQ, 5, 0 );

			SendMessage( hYUVFilterThresholdPCent, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hYUVFilterThresholdPCent, TBM_SETRANGEMIN, TRUE, -100 );
			SendMessage( hYUVFilterThresholdPCent, TBM_SETTICFREQ, 5, 0 );

			SendMessage( hPix, TBM_SETRANGEMAX, TRUE, 50 );
			SendMessage( hPix, TBM_SETRANGEMIN, TRUE, 1 );
			SendMessage( hPix, TBM_SETTICFREQ, 5, 0 );

			SetTimer(hDlg,0,20,NULL);
			SetDlgItemInt(hDlg, IDC_TESTZEILEN, MasterTestzeilen, TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT1,TZ[0],TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT2,TZ[1],TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT3,TZ[2],TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT4,TZ[3],TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT5,TZ[4],TRUE);

			CheckDlgButton(hDlg, IDC_CHECK1, VideoPlugin.FullField);
            CheckDlgButton(hDlg, IDC_CHECK2, PalPlusActive);
			CheckDlgButton(hDlg, IDC_CHECK6, VideoPlugin.VIA_FIX);
			SetDlgItemInt(hDlg,IDC_EDIT6,VideoPlugin.VIA_FIX_X,FALSE);
			if(!VideoPlugin.VIA_FIX)
			{
				EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),FALSE);
			}
			if(VideoPlugin.FullField==FALSE)
			{
				EnableWindow(GetDlgItem(hDlg,IDC_CHECK6),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),FALSE);
			}

			SetDlgItemInt(hDlg,IDC_LOW,InitialLow,FALSE);
			CheckDlgButton(hDlg, IDC_CHECK3, VideoPlugin.AutoProcessVideo);

			TUFilter=iUFilterThresholdPCent;
			TVFilter=iVFilterThresholdPCent;
			TYUVFilter=iYUVFilterThresholdPCent;
			TPix=iPixFilterThreshold;
			TLow=InitialLow;
			
			SendMessage( hUFilterThresholdPCent,   TBM_SETPOS, TRUE, -iUFilterThresholdPCent );
			SetDlgItemInt(hDlg,IDC_D1,iUFilterThresholdPCent,FALSE);
			
			SendMessage( hVFilterThresholdPCent,   TBM_SETPOS, TRUE, -iVFilterThresholdPCent );
			SetDlgItemInt(hDlg,IDC_D2,iVFilterThresholdPCent,FALSE);

			SendMessage( hYUVFilterThresholdPCent,   TBM_SETPOS, TRUE, -iYUVFilterThresholdPCent );
			SetDlgItemInt(hDlg,IDC_D3,iYUVFilterThresholdPCent,FALSE);

			SendMessage( hPix,   TBM_SETPOS, TRUE, iPixFilterThreshold );
			SetDlgItemInt(hDlg, IDC_D4,iPixFilterThreshold,FALSE);
			InitFullField = VideoPlugin.FullField;
			break;

		case WM_HSCROLL:
	        if((HWND)lParam == hPix)
			{
				iPixFilterThreshold = SendMessage( hPix,   TBM_GETPOS, 0, 0 );
				SetDlgItemInt(hDlg,IDC_D4,iPixFilterThreshold,FALSE);
			}
			break;

		case WM_VSCROLL:
	        if((HWND)lParam == hUFilterThresholdPCent)
			{
				iUFilterThresholdPCent = -SendMessage( hUFilterThresholdPCent,   TBM_GETPOS, 0, 0 );
				SetDlgItemInt(hDlg,IDC_D1,iUFilterThresholdPCent,FALSE);
				nUThreshold= (int) (iUFilterThresholdPCent*0.01*0xff);
			}
	        else if((HWND)lParam == hVFilterThresholdPCent)
			{
				iVFilterThresholdPCent = -SendMessage( hVFilterThresholdPCent,   TBM_GETPOS, 0, 0 );
				SetDlgItemInt(hDlg,IDC_D2,iVFilterThresholdPCent,FALSE);
				nVThreshold= (int) (iVFilterThresholdPCent*0.01*0xff);
			}
	        else if((HWND)lParam == hYUVFilterThresholdPCent)
			{
				iYUVFilterThresholdPCent = -SendMessage( hYUVFilterThresholdPCent,   TBM_GETPOS, 0, 0 );
				SetDlgItemInt(hDlg,IDC_D3,iYUVFilterThresholdPCent,FALSE);
				nYUVThreshold= (int) (iYUVFilterThresholdPCent*0.01*0xff);
			}
			break;

		case WM_COMMAND:
			switch (wParam)
			{
			case IDC_CHECK1 :
				if ( IsDlgButtonChecked( hDlg, IDC_CHECK1)) {

					EnableWindow(GetDlgItem( hDlg,IDC_CHECK6),TRUE);

					if ( IsDlgButtonChecked( hDlg, IDC_CHECK6)) {

						EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),TRUE);

						EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),TRUE);
					} else {

						EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),FALSE);

						EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),FALSE);
					}
				} else {

					EnableWindow(GetDlgItem(hDlg,IDC_CHECK6),FALSE);

					EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),FALSE);

					EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),FALSE);
				}
				break;

/*			case IDC_CHECK1 :
					if(IsDlgButtonChecked(hDlg, IDC_CHECK1))
					{
						EnableWindow(GetDlgItem(hDlg,IDC_CHECK6),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),TRUE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg,IDC_CHECK6),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),FALSE);
					}
					break;
*/
				case IDC_CHECK6 :
					if(IsDlgButtonChecked(hDlg, IDC_CHECK6))
					{
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),TRUE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),FALSE);
					}
					break;
						 
				case IDC_BUTTON1:
					DialogBox(VideoPlugin.hDllInstance,"ABOUT",hDlg,(DLGPROC)AboutProc);
					break;

				case IDOK :
					MasterTestzeilen=GetDlgItemInt(hDlg, IDC_TESTZEILEN, NULL,TRUE);
					if (MasterTestzeilen < 8 ) MasterTestzeilen=8;
					else if (MasterTestzeilen > 80 ) MasterTestzeilen=80;

					TZ[0]=GetDlgItemInt(hDlg, IDC_EDIT1, NULL, TRUE);
					TZ[1]=GetDlgItemInt(hDlg, IDC_EDIT2, NULL,TRUE);
					TZ[2]=GetDlgItemInt(hDlg, IDC_EDIT3, NULL,TRUE);
					TZ[3]=GetDlgItemInt(hDlg, IDC_EDIT4, NULL,TRUE);
					TZ[4]=GetDlgItemInt(hDlg, IDC_EDIT5, NULL,TRUE);
					VideoPlugin.VIA_FIX_X=GetDlgItemInt(hDlg, IDC_EDIT6, NULL,TRUE);
					if (VideoPlugin.VIA_FIX_X > 768)	
						VideoPlugin.VIA_FIX_X=768;
					else if (VideoPlugin.VIA_FIX_X < 386)	
						VideoPlugin.VIA_FIX_X=386;
                    Swap=TRUE;
					while ( Swap == TRUE )
					{
						Swap=FALSE;
						for ( i=0; i < 4 ; i++ )
						{
							if ( TZ[i] > TZ[i+1] )
							{
								Swap=TRUE;
                                j=TZ[i];
								TZ[i]=TZ[i+1];
								TZ[i+1]=j;
							}
						}
					}

                    for ( i=0; i < 4 ; i++ )
					{
						if (TZ[i] < 8 ) TZ[i]=8;
						else if (TZ[i] > 80 ) TZ[i]=80;
					}
                    VideoPlugin.FullField=IsDlgButtonChecked(hDlg, IDC_CHECK1);
                    PalPlusActive=IsDlgButtonChecked(hDlg, IDC_CHECK2);
					VideoPlugin.VIA_FIX=IsDlgButtonChecked(hDlg, IDC_CHECK6);
			        InitialLow=GetDlgItemInt(hDlg,IDC_LOW,NULL,FALSE);
//					SetBrightness(InitialBrightness);

					VideoPlugin.AutoProcessVideo=IsDlgButtonChecked(hDlg, IDC_CHECK3);
//
					// Si fullfield a t chang alors toggle
					// #define IDM_FullFields                  360
					if (InitFullField != VideoPlugin.FullField)
						SendMessage(VideoPlugin.hwndParent, WM_COMMAND, 360, 0);
					Write_INI();
					EndDialog(hDlg,TRUE);
					break;

				case IDDEFAULT :
					VideoPlugin.VIA_FIX_X=638;
					SetDlgItemInt(hDlg,IDC_EDIT6, VideoPlugin.VIA_FIX_X,FALSE);
						
					InitialLow=45;
					SetDlgItemInt(hDlg,IDC_LOW,InitialLow,FALSE);

					iUFilterThresholdPCent=63;
					SendMessage( hUFilterThresholdPCent,   TBM_SETPOS, TRUE, -iUFilterThresholdPCent );
					SetDlgItemInt(hDlg,IDC_D1,iUFilterThresholdPCent,FALSE);

					iVFilterThresholdPCent=63;
					SendMessage( hVFilterThresholdPCent,   TBM_SETPOS, TRUE, -iVFilterThresholdPCent );
					SetDlgItemInt(hDlg,IDC_D2,iVFilterThresholdPCent,FALSE);

					iYUVFilterThresholdPCent=43;
					SendMessage( hYUVFilterThresholdPCent,   TBM_SETPOS, TRUE, -iYUVFilterThresholdPCent );
					SetDlgItemInt(hDlg,IDC_D3,iYUVFilterThresholdPCent,FALSE);

					iPixFilterThreshold=20;
					SendMessage( hPix,   TBM_SETPOS, TRUE, iPixFilterThreshold );
					SetDlgItemInt(hDlg, IDC_D4,iPixFilterThreshold,FALSE);

					break;
					  
				case IDCANCEL :
					iPixFilterThreshold=TPix;
					InitialLow=TLow;
					iUFilterThresholdPCent=TUFilter;
					iVFilterThresholdPCent=TVFilter;
					iYUVFilterThresholdPCent=TYUVFilter;
					EndDialog(hDlg, TRUE) ;
					break;
            }
            break ;
	}
	return FALSE ;
}
