/////////////////////////////////////////////////////////////////////////////
// DiversDeco.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Grincheux  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <stdio.h>

#include "general.h"
#include "diversdeco.h"
#include "deco.h"

BOOL 
Line286BlackEven, Line286BlackOdd, 
Line285BlackEven, Line285BlackOdd, 
Line0BlackEven,   Line0BlackOdd, 
Line1BlackEven,   Line1BlackOdd, 
MatrixModeEven,   MatrixModeOdd;

int B0e, B1e, B285e, B286e, B0o, B1o, B285o, B286o;
extern BOOL MoreLinesLock;

int BlackEven=-1, BlackOdd=-1, UntilEven=0, UntilOdd=0;
int FirstWidthEven=TESTPIXEL, FirstWidthOdd=TESTPIXEL;
int FirstWidthEvenCount=0,    FirstWidthOddCount=0;
int MatrixLinesEven=0, MatrixLinesOdd=0;
int MatrixCountEven=0, MatrixCountOdd=0;
BOOL  BlackSet[288];
int AutoLockCount=0;





BOOL Check_Even( void )
{
	int m=0, i;
	
	if (( Line0BlackEven == TRUE ) && (!BlackSet[pSortLinesEven[0]])) return(FALSE);
	if (( Line1BlackEven == TRUE ) && (!BlackSet[pSortLinesEven[1]])) return(FALSE);
	if (( Line285BlackEven == TRUE ) && (!BlackSet[pSortLinesEven[285]])) return(FALSE);
	if (( Line286BlackEven == TRUE ) && (!BlackSet[pSortLinesEven[286]])) return(FALSE);
	
	if ( MatrixModeEven == TRUE )
	{
		for ( i=0 ; i < 68 ; i++ )
		{
			if ( BlackSet[pSortLinesEven[i]]==TRUE ) m++;
		}
		if ( m < MatrixLinesEven ) return(FALSE);
	}
	return(TRUE);
}



BOOL Check_Odd( void )
{
	int m=0, i;
	
	if (( Line0BlackOdd == TRUE ) && (!BlackSet[pSortLinesOdd[0]])) return(FALSE);
	if (( Line1BlackOdd == TRUE ) && (!BlackSet[pSortLinesOdd[1]])) return(FALSE);
	if (( Line285BlackOdd == TRUE ) && (!BlackSet[pSortLinesOdd[285]])) return(FALSE);
	if (( Line286BlackOdd == TRUE ) && (!BlackSet[pSortLinesOdd[286]])) return(FALSE);
	
	if ( MatrixModeOdd == TRUE )
	{
		for ( i=0 ; i < 68 ; i++ )
		{
			if ( BlackSet[pSortLinesOdd[i]]==TRUE ) m++;
		}
		if ( m < MatrixLinesOdd ) return(FALSE);
	}
	return(TRUE);
}


void Init_More()
{
	if ( MoreLinesLock == FALSE )
	{
		AutoLockCount=0;
		UntilEven=0;
		UntilOdd=0;
		BlackEven=-1;
		BlackOdd=-1;
		MoreLinesLock=FALSE;  
		FirstWidthEven=TESTPIXEL;
		FirstWidthOdd=TESTPIXEL;
		FirstWidthEvenCount=0;
		FirstWidthOddCount=0;
		Line286BlackEven=FALSE;
		Line286BlackOdd=FALSE;
		Line1BlackEven=FALSE;
		Line1BlackOdd=FALSE;
		B1e=0;
		B286e=0;
		B1o=0;
		B286o=0;
		MatrixCountEven=0;
		MatrixModeEven=FALSE;
		MatrixLinesEven=0;
		MatrixCountOdd=0;
		MatrixModeOdd=FALSE;
		MatrixLinesOdd=0;
	}
}


void Clear_Status()
{
	AutoLockCount=0;
	UntilEven=0;
	UntilOdd=0;
    BlackEven=-1;
    BlackOdd=-1;
	FirstWidthEvenCount=0;
	FirstWidthOddCount=0;
    FirstWidthEven=TESTPIXEL;
    FirstWidthOdd=TESTPIXEL;
	Line286BlackEven=FALSE;
	Line286BlackOdd=FALSE;
	Line285BlackEven=FALSE;
	Line285BlackOdd=FALSE;
	Line0BlackEven=FALSE;
	Line0BlackOdd=FALSE;
	Line1BlackEven=FALSE;
	Line1BlackOdd=FALSE;
	MatrixModeEven=FALSE;
	MatrixModeOdd=FALSE;
	MatrixCountEven=0;
	MatrixCountOdd=0;
	MoreLinesLock=FALSE;
}

void More_Even( int pp )
{
	int i, m=0, j;

    if ( BlackSet[pSortLinesEven[0]] )
	{
		if ( B0e < 100 ) B0e++;
		else Line0BlackEven=TRUE;
		FirstWidthEvenCount=0;
	}
	else
	{
		B0e=0;
		if (( Line0BlackEven==TRUE ) &&
		   ( FirstWidthEven<TESTPIXEL)) FirstWidthEven++;
        FirstWidthEvenCount++;
        Line0BlackEven=FALSE;
	}

    if ( BlackSet[pSortLinesEven[1]] )
	{
		if ( B1e < 100 ) B1e++;
		else Line1BlackEven=TRUE;
	}
	else
	{
		B1e=0;
        Line1BlackEven=FALSE;
	}

    if ( BlackSet[pSortLinesEven[286]] )
	{
		if ( B286e < 100 ) B286e++;
		else Line286BlackEven=TRUE;
	}
	else
	{
		B286e=0;
        Line286BlackEven=FALSE;
	}

    if ( BlackSet[pSortLinesEven[285]] )
	{
		if ( B285e < 100 ) B285e++;
		else Line285BlackEven=TRUE;
	}
	else
	{
		B285e=0;
        Line285BlackEven=FALSE;
	}
	
	if (( FirstWidthEvenCount > 100 ) && ( FirstWidthEven >3 ))
	{
		FirstWidthEvenCount=80;
		if (( MatrixModeEven == FALSE ) &&
			( Line0BlackEven == FALSE ) &&
			( Line1BlackEven == FALSE ))
		{
		AutoLockCount=0;
		FirstWidthEven--;
		}
	}

	if ( pp >= 0 ) BlackSet[pp]=TRUE;

	for ( i=0 ; i < 68 ; i++ )
	{
		if ( BlackSet[pSortLinesEven[i]]==TRUE ) m++;
	}

	j=m;
	for ( i=68 ; i < 287 ; i++ )
	{
		if ( BlackSet[pSortLinesEven[i]]==TRUE ) j++;
	}

	if ( j != BlackEven )
	{
		AutoLockCount=0;
		BlackEven = j;
	} 

	if (( m < 6 ) || ( m > 66 ))
	{
		MatrixModeEven=FALSE;
	    MatrixCountEven=0;
		MatrixLinesEven=0;
        return;
	}

	if ( MatrixCountEven == 0 )
	{
	   MatrixLinesEven=m;
	   MatrixCountEven++; 
	}
	else
	{
		if ( m==MatrixLinesEven )
		{ 
			if ( MatrixCountEven < 100 ) MatrixCountEven++; 
		}
		else MatrixCountEven-=10;
	 
		if ( MatrixCountEven < 0 )
		{
			MatrixCountEven=0;
			MatrixModeEven=FALSE;
			MatrixLinesEven=0;
			return;
		}
 
		if ( MatrixCountEven > 80)
		{
			if ( MatrixModeEven == FALSE )
			{
				MatrixModeEven=TRUE;
		        GetMatrix(MatrixLinesEven-1,0);
			}
		}
	}
}

void More_Odd()
{
	int m=0, i, j;
	
    if ( BlackSet[pSortLinesOdd[0]] )
	{
		if ( B0o < 100 ) B0o++;
		else Line0BlackOdd=TRUE;
		FirstWidthOddCount=0;
		
	}
	else
	{
		B0o=0;
		if (( Line0BlackOdd==TRUE ) && ( FirstWidthOdd<TESTPIXEL)) FirstWidthOdd++;
		FirstWidthOddCount++;
        Line0BlackOdd=FALSE;
	}
	
	
    if ( BlackSet[pSortLinesOdd[1]] )
	{
		if ( B1o < 100 ) B1o++;
		else Line1BlackOdd=TRUE;
	}
	else
	{
		B1o=0;
        Line1BlackOdd=FALSE;
	}
    if ( BlackSet[pSortLinesOdd[286]] )
	{
		if ( B286o < 100 ) B286o++;
		else Line286BlackOdd=TRUE;
	}
	else
	{
		B286o=0;
        Line286BlackOdd=FALSE;
	}
    if ( BlackSet[pSortLinesOdd[285]] )
	{
		if ( B285o < 100 ) B285o++;
		else Line285BlackOdd=TRUE;
	}
	else
	{
		B285o=0;
        Line285BlackOdd=FALSE;
	}
	
	
	if (( FirstWidthOddCount > 100 ) && ( FirstWidthOdd > 3 ))
	{
		FirstWidthOddCount=75;
		if (( MatrixModeOdd == FALSE ) && ( Line0BlackOdd == FALSE ) && ( Line1BlackOdd == FALSE ))
		{
			FirstWidthOdd--;
			AutoLockCount=0;
		}
	}
	
	for ( i=0 ; i < 68 ; i++ )
	{
		if ( BlackSet[pSortLinesOdd[i]]==TRUE ) m++;
	}
	
	j=m;
	for ( i=68 ; i < 287 ; i++ )
	{
		if ( BlackSet[pSortLinesOdd[i]]==TRUE ) j++;
	}
	
	if ( j != BlackOdd )
	{
		AutoLockCount=0;
		BlackOdd = j;
	} 
	
	
	if (( m < 6 ) || ( m > 66 ))
	{
		MatrixCountOdd=0;
		MatrixLinesOdd=0;
		return;
	}
	if ( MatrixCountOdd == 0 )
	{
		MatrixLinesOdd=m;
		MatrixCountOdd++; 
	}
	else
	{
		if ( m==MatrixLinesOdd )
		{
			if ( MatrixCountOdd < 100 ) MatrixCountOdd++; 
		}
		else MatrixCountOdd-=10;
		
		if ( MatrixCountOdd < 0 )
		{
			MatrixCountOdd=0;
			MatrixModeOdd=FALSE;
			MatrixLinesOdd=0;
			return;
		}
		
		if ( MatrixCountOdd > 60 )
		{
			if ( MatrixModeOdd == FALSE )
			{
				MatrixModeOdd=TRUE;
				GetMatrix(MatrixLinesOdd-1,1);
			}
		}
	}
}
