/////////////////////////////////////////////////////////////////////////////
// FiltresVideo.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Grincheux  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>       // required for all Windows applications
#include <stdio.h>

#include "general.h"


int nYUVThreshold, nUThreshold, nVThreshold, iLine, nPixThreshold;

const __int64 nMaskeU  = 0x0000FF000000FF00; //snabrab
const __int64 nMaskeV  = 0xFF000000FF000000; //snabrab
const __int64 nMaskeUV = 0xFF00FF00FF00FF00;

int NbFramesManquantes();
int TestCorrectionUV(DWORD *pQuelle, DWORD *pSauve, DWORD *pColorQuelle, DWORD MasqueUV);
int LineSaturation(DWORD *pQuelle, int CountX, int iLine_bugne, int iLine_sort, int Zone2_bugne);
extern int StartAff;

// -------------------------------------------------------------
// snabrab 27/05/2001
// a) progrs important du filtrage bleu sur la zone infrieure :
// caractrisation de leur apparition SANS recourir au test de saturation
// des couleurs >> plus d'erreur de dtection sur la partie bugne bleu/violette infrieure
// mme sur des images fortement colores.

// b) progrs secondaire sur le rephasage anti-bavure automatique li  a):
// on n'effectue le test de rephasage qu'en cas d'apparition
// des lignes bleues en a)

// -------------------------------------------------------------
// snabrab Modififications du Filtres KizKoool SECAM v3.2
// a)filtrage violette avant et aprs destroumpfage sur seulement
// 1/4 des lignes

// b) Sur 2 zones, filtrage par bloc avec un seuil de lignes bugnes
// pour diminuer fausse dtection

// c)rephasage antibavure amliore par meilleure localisation des lignes bugnes testes

// ------------------------------------------------------------
// Filtres KizKoool SECAM v3.2
//
// Filtre lignes violettes + filtre anti-bavures
//
// Premires fonctions de traitement SECAM par Fantasio
// Ancien filtre bleu ASM par 1konnu
//
// Nouvel algorithme de dtection des lignes satures + bugfixes +
// traduction en C du filtre bleu et optimisations par KizKoool
//
// Ide et code original du filtre anti-bavures par 1Konnu
//
// Adaptation  K!TV + optimisations +
// rephasage dynamique du filtre anti-bavures par KizKoool
//
// Ide de l'exploitation de la variable CurrentFrame par E-nek
// Symbiose optimale des 2 filtres par Grincheux et KizKoool
//--------------------------------------------------------------



void SecamFiltering(DWORD **pLinesAddress, int *pSortLines)
{
	// Taille maximale d'une frame 768*287
	static BYTE ColorBackup[768 * ZEILENZAHL];
	BYTE *pColorQuelle, *pColorBuffer, *pQuelle, *pSource, *pix_courant;

	//snabrab
	int pSortLines_inverse[ZEILENZAHL],saturee2;
	BOOL Zone2_bugne=0;//snabrab

	//snabrab : inverse de pSortLines
	for (iLine=0; iLine <ZEILENZAHL; iLine++)
	{
		pSortLines_inverse[pSortLines[iLine]]=iLine;
	}



	nPixThreshold= (int) ((CurrentX*iPixFilterThreshold)/200);


	if (bFilterBlueLines)
	{
		//snabrab : 2 me zone, dtection bloc bugn AVANT dstroumpf
		saturee2=0;
		Zone2_bugne=0;
		for (iLine=32; iLine <52; iLine++)
		{
			if (LineSaturation((DWORD *)pLinesAddress[iLine], CurrentX>>1,0,0,0))
			//utilise la test de saturation "standard" par KIZKOOL
			{
				saturee2++;
			}
		}

		if (saturee2>11) // Bloc sature
		{
			Zone2_bugne=1;
		}
	} // fin if bFilterBlueLines

	_asm movq mm7, nMaskeUV


	// fameuse boucle KIZKOOL et GRINCHEUX OPTIMALE pour bavure+bleu
	for (iLine=StartAff+VideoPlugin.MovieBoost*StartAff; iLine < ZEILENZAHL-VideoPlugin.MovieBoost*StartAff; iLine++)
	{
	// pQuelle: pointeur sur la ligne source dans l'image dcode:
	pQuelle = (BYTE*) pLinesAddress[pSortLines[iLine]];
	// pColorBuffer: pointeur sur les couleurs non satures du buffer
	pColorBuffer = (BYTE*) (ColorBackup + CurrentX * iLine);

		//snabrab : test de saturation de la ligne, fonction modifie
		if (bFilterBlueLines && (LineSaturation(pLinesAddress[pSortLines[iLine]], CurrentX>>1,pSortLines[iLine],iLine,Zone2_bugne)))
		{
			// Ligne sature
			// Restauration de la saturation  partir du buffer de lignes non satures
			for (pix_courant=pQuelle+1; pix_courant<pQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
			{
				*pix_courant=*pColorBuffer;
				*(pix_courant+2)=*(pColorBuffer+1);
				pColorBuffer=pColorBuffer+2;
			}
		}
		else
		{
			// Ligne non sature ou pas de filtre bleu
			// 1) Application du filtre anti-bavures

			if(iLine!=StartAff+VideoPlugin.MovieBoost*StartAff)
			{
				// pColorQuelle: pointeur sur la ligne precedente dans l'image dcode:
				pColorQuelle=(BYTE*)pLinesAddress[pSortLines[iLine-1]];

				if ((((iLine%2)==0) && TypeImage) || (((iLine%2)!=0) && !TypeImage))
				{
					// ligne paire de l'image de type 1 ou ligne impaire de l'image de type 2
					pSource=pQuelle+3;
					for (pix_courant=pColorQuelle+3; pix_courant<pColorQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
					{
						*pSource=*pix_courant;
						pSource=pSource+4;
					}
				}
				else
				{
					// ligne impaire de l'image de type 1 ou ligne paire de l'image de type 2
					pSource=pQuelle+1;
					for (pix_courant=pColorQuelle+1; pix_courant<pColorQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
					{
						*pSource=*pix_courant;
						pSource=pSource+4;
					}
				}
			}

			// 2) Stockage de la ligne dans le buffer de lignes non satures
			if (bFilterBlueLines)
				/*
				for (pix_courant=pQuelle+1; pix_courant<pQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
				{
					*pColorBuffer= *pix_courant;
					*(pColorBuffer+1)= *(pix_courant+2);
					pColorBuffer=pColorBuffer+2;
				}
				/*/

		// snabrab : traduction en ASM MMX plus rapide que c++
		// (-1% cpu en moins sur celeron 450 mhz)
		_asm {
//			pushad
			mov edi,pColorBuffer  //zone stockage
			mov eax,CurrentX

			mov esi,pQuelle       //encours
			mov edx,eax

//			movq mm7, nMaskeUV
			

//			xor edx,edx
//			mov ecx,4
//			div ecx // on divise le nbre de poins par 4, EAX quotient EDX reste

			shr eax,2//division par 4
			and edx,3//reste de la division par 4

			// si edx>0 : on traite les edx points (non multiple de 4)
			//cmp edx,0 //implicite dans le 'and'
			
			je PixSui3

			movq mm0,qword ptr [esi] //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
			
//			pand mm0,mm7 //maskeUV V2 00 U2 00 V0 00 U0 00
//le mask est inutile car le shift sur 16bit fait l'equivalent...

			psrlw mm0,8 //0 V2 0 U2 0 V1 0 U1
			add esi, edx

			packuswb mm0, mm0 //V2U2V1U1V2U2V1U1
			add esi, edx

			movd dword ptr [edi], mm0
			
			add edi, edx
			// fin traitement des edx points

			align 16
		PixSui3:  // boucle pour stocker les points restants (multiples de 4)
			movq mm0,qword ptr [esi] //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0

//			pand mm0,mm7 //maskeUV V2 00 U2 00 V0 00 U0 00
			add edi,4
			psrlw mm0,8 //0 V2 0 U2 0 V1 0 U1

			add esi,8
			packuswb mm0, mm0 //V2U2V1U1V2U2V1U1

			dec eax
		
			movd dword ptr [edi-4], mm0
			jg PixSui3

			emms
//			popad
			} // fin asm
		} // fin de else
	} // boucle for

} // fin void SecamFiltering





// snabrab : Fonction dtection lign sature, modifie pour filtrage par zone
// Zone 1 de ligne 0  21 image stroumpfe
// Zone 2 de ligne 32  51 image stroumpfe
// Zone 4 de ligne ZEILENZAHL-32  ZEILENZAHL-1 image dstroumpfe
// Paramtres:
// pQuelle: Pointeur vers la ligne  tester
// CountX: Nombre de pixels  tester
// iLine_bugne : position ligne dans image non dschtroumpfe
// iLine_sort : position ligne dans image dschtroumpfe
// Zone2_bugne : flag indiquant si tout le bloc de lignes Zone 2 est schtroumpf
int LineSaturation(DWORD *pQuelle, int CountX, int iLine_bugne, int 
iLine_sort, int Zone2_bugne)
{
	DWORD *pix_courant;
	long U, V, Y, Seuil_NbPix;

if (iLine_bugne<22) //snabrab : 1 ere zone, dtection bugne AVANT dstroumpf
{
	// Test de saturation de ligne par KizKoool
	Seuil_NbPix=nPixThreshold;
	pix_courant=pQuelle;
	while ((pix_courant<pQuelle+CountX) && (Seuil_NbPix>0))
	{
		U = *pix_courant>>8 & 0xff;
		V = *pix_courant>>24 & 0xff;
		Y = ((*pix_courant>>16 & 0xff)+(*pix_courant & 0xff))>>2;

		if ( !((((U>>1)+V)>Y+nYUVThreshold) && ((U>nUThreshold) || (V>nVThreshold))) )
			{
				Seuil_NbPix-=1;
			}
			pix_courant++;
	}
	return (Seuil_NbPix>0);
}
else
	{
	if ((iLine_bugne>31) && (iLine_bugne<52))
		{
		return (Zone2_bugne);
		}
	else
		{
			if (iLine_sort>=ZEILENZAHL-32)
				{
				return ((iLine_sort%2!=iLine_bugne%2));
				}
			else
				{
				return (1<0);
				}
		}
	}

}


//
// Rephasage dynamique du filtre anti-bavures par KizKoool
// Algorithme bas sur les proprits des lignes satures
//
void FindFrameType(DWORD **pLinesAddress, int *pSortLines)
{
	DWORD *pQuelle, *pColorQuelle,*pLineBackup;
	static DWORD LineColorBackup[768];
	unsigned long MasqueToutSaufU, MasqueToutSaufV;
	int nb_saturees1, nb_saturees2;
	int pSortLines_inverse[ZEILENZAHL]; //snabrab
	nb_saturees1=0;
	nb_saturees2=0;

	MasqueToutSaufU = 0xFFFF00FF;	// Garde tout sauf la composante U
	MasqueToutSaufV = 0x00FFFFFF;	// Garde tout sauf la composante V


	// Dtection des frames loupes
	if (NbFramesManquantes() != 0)TypeImage=!(TypeImage);
	if ((pSortLines[ZEILENZAHL-1])%2!=(ZEILENZAHL-1)%2)
	// snabrab : Dtection simple et trs sure des lignes bugnes infrieures
	// on ne cale la phase que quand il y a des lignes bugnes
	// plus rapide et moins d'erreur

	{
	pLineBackup = (DWORD*) LineColorBackup;
	nPixThreshold = (int) ((CurrentX*iPixFilterThreshold)/200);

	//snabrab : inverse de pSortLines
	for (iLine=0; iLine <ZEILENZAHL; iLine++)
	{
		pSortLines_inverse[pSortLines[iLine]]=iLine;
	}

	//modif snabrab : slection plus prcises des lignes bugnes  tester
	for (iLine=ZEILENZAHL-15; iLine < ZEILENZAHL; iLine++)
	{
		if (((pSortLines[iLine]+1)<ZEILENZAHL)&&(pSortLines_inverse[pSortLines[iLine]+1]<ZEILENZAHL-32)) 
		// snabrab
		{
			pQuelle = (DWORD*) pLinesAddress[pSortLines[iLine]+1]; //modifi snabrab
			pColorQuelle = (DWORD*)
			pLinesAddress[pSortLines[pSortLines_inverse[pSortLines[iLine]+1]-1]];

			if (((((pSortLines_inverse[pSortLines[iLine]+1])%2)==0) && TypeImage) || ((((pSortLines_inverse[pSortLines[iLine]+1])%2)!=0) && !TypeImage)) 
			//modifi snabrab
			{
				// ligne paire de l'image de type 1
				// ou ligne impaire de l'image de type 2
				nb_saturees1+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufV);
				nb_saturees2+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufU);
			}
			else
			{
				// ligne impaire de l'image de type 1
				// ou ligne paire de l'image de type 2
				nb_saturees1+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufU);
				nb_saturees2+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufV);
			}
		}
	}

	// Test de rephasage

	if ((nb_saturees1>nb_saturees2+4) && (min(nb_saturees1,nb_saturees2)<4))
		TypeImage=!(TypeImage);
	}
}

//
// Dtection des frames manquantes par KizKoool
// Sur une ide d'exploiter la variable CurrentFrame d'E-nek
//
// Valeur de retour:
// Nombre de frames non acquises
//
int NbFramesManquantes()
{
	static int PrecedentFrame=-1;
	int NbFramesLoupees;

	if (CurrentFrame>PrecedentFrame)
		NbFramesLoupees=CurrentFrame-PrecedentFrame-1;
	else
		NbFramesLoupees=CurrentFrame-PrecedentFrame+4;

	PrecedentFrame = CurrentFrame;

	return NbFramesLoupees;
}

//
// Test de correction des Couleurs UV par KizKoool
//
// Paramtres :
// pQuelle      : Source
// pSauve       : Destination
// pColorQuelle : Rfrence pour reconstituer la couleur
// MasqueUV     : Masque de correction
//
int TestCorrectionUV(DWORD *pQuelle, DWORD *pSauve, DWORD *pColorQuelle,
DWORD MasqueUV)
{
    unsigned long MasqueInverse;
	DWORD *pix_courant;
	MasqueInverse= ~MasqueUV;
	
	for (pix_courant=pSauve; pix_courant<pSauve+(CurrentX>>1); pix_courant++)
	{
		*pix_courant=((*pQuelle & MasqueUV) | (*pColorQuelle & MasqueInverse));
		pColorQuelle++; pQuelle++;
	}
	return LineSaturation(pSauve, CurrentX>>1,0,0,0);
}


